' $linesize:132
' $title: 'RBBSSUB2.BAS 17.5, Copyright 1986 - 94 by D. Thomas Mack'
'  Copyright 1991 by D. Thomas Mack, all rights reserved.
'  Name ...............: RBBSSUB2.BAS
'  First Released .....: June 21, 1992
'  Subsequent Releases.:
'  Copyright ..........: 1986 - 1994
'  Purpose.............: The Remote Bulletin Board System for the IBM PC,
'     RBBS-PC.BAS utilizes a lot of common subroutines.  Those that do not
'     require error trapping are incorporated within RBBSSUB 2-7 as
'     separately callable subroutines in order to free up as much
'     code as possible within the 64K code segment used by RBBS-PC.BAS.
'  Parameters..........: Most parameters are passed via a COMMON statement.
'
' Subroutine       Line        Function of Subroutine
'   Name           Number
' ----------       ------      ----------------------
'  AliasChk        9900        Validate that ALIAS exists.  Get User Record
'  AliasDGS        9960        Create/Update Alias Info file
'  AnswerIt         200        Answer the telephone when it rings
'  ASCIICodes       129        Allow a CONFIG string to have any ASCII value
'  BadChar          455        Check user name for invalid characters
'  BankTime        5500        Let caller change banked time
'  CheckMacro      1320        Checks for macro and processes
'  CopyRight         97        Display RBBS-PC's copyright notice
'  DefaultU        9600        Write out the user's defaults
'  DenyAccess      1386        Downgrade security so access denied
'  EditALine       2618        Edits a single line
'  EditDef          120        Edit configuration parameters
'  FindFileNumber 86500        To locate file by number
'  GetCommand       101        Get RBBS-PC's node id from command line
'  GetTime         9140        Calculates callers elapsed time (hh,mm,ss)
'  GoodAls         9960        Make Sure Alias is Good
'  GoIdle            90        Release resources when waiting for keyboard input
'  IConference    10000        Read the I.DEF file
'  KillMsg         3952        Delete old or unnecessary messages
'  Line25           945        Build and/or update line 25 of RBBS-PC's local screen
'  LineEdit        3700        Edit a line while minimizing string space consumption
'  LPrnt           1480        Write to local display
'  Macro           1325        Check/execute macro
'  MsgProt         2055        Sets protection for a message
'  ParseIt         1637        Parses a string
'  PassWrd          660        Verify user & message passwords
'  PopCmdStack     1650        Get user input, 1st checking command stack
'  PScrn           1483        Print to display
'  QuickLPrnt      1482        Quickly writes count of blocks on file transfer
'  QuickTPut       1478        Fast, but limited, "TPut" equivalent
'  QuickTPut1      1478        Outputs short string following by CR LF
'  ReadXfer       85000        Read the XFER-?.DEF File
'  RemNonAlf       5100        Removes non-alpha characters from a string
'  RingCaller      1636        Ring caller's bell and puts message in emphasis
'  SetBaud         1654        Set baud rate in the 8250 chip of the RS232 interface
'  SetCrLf         1496        Set up the necessary carriage return/line feed string
'  SetWhoTo        2018        Sets who a message/personal upload is to
'  SetThread       4554        Set up request for threading thru messages
'  SkipLine        1485        Write a # of blank lines to the communications port
'  SearchCmd       1238        Searches list of commands in RBBS for a request
'  SecViolation    1380        Process a security violation
'  SysMenu          112        Displays sysop menu/status
'  SysopChat       4773        Sysop and caller chat
'  TestRel          336        Tests for Reliable connect
'  TGet            1498        Read a line from the communications port
'  TPut            1396        Write a line to the communications port
'  Trim             105        Strip leading and trailing blanks from a string
'  TrimTrail        107        Strip off specified string off end of another string
'  VarInit          109        Initialize system variables
'  ViewHelp        1330        Processes help command
'  WhoCheck        2250        Checks whether a user exists in user file
'  WhosOn          9801        Report status of each node - who's on
'
'  $INCLUDE: 'RBBS-VAR.BAS'
'
90 '  $SUBTITLE: 'GoIdle - release control when waiting'
'  $PAGE
'
'  NAME    -- GoIdle
'
'  INPUTS  -- ZMLCom
'             ZNetworkType
'
'  OUTPUTS --  NONE
'
'  PURPOSE --  To relinquish control when RBBS-PC is waiting for
'              input from the communications port
'
   SUB GoIdle
   CALL GiveBack
   END SUB
'
97 '  $SUBTITLE: 'CopyRight - subroutine to display RBBS-PC copyright'
'  $PAGE
'
'  NAME    -- CopyRight
'
'  INPUTS  --  NONE
'
'  OUTPUTS --  NONE
'
'  PURPOSE --  To display RBBS-PC's copyright notice on the local screen
'
      SUB CopyRight
   ZWasA = (ZDebug OR ZExitToDoors OR ZCopyrightSecs < 1)
   IF ZWasA THEN _
      EXIT SUB
   WIDTH 80
   ZOutTxt$(1) = "If you use RBBS-PC 17.5, please consider contributing to"
   ZOutTxt$(2) = "             Capital PC User Group"
   ZOutTxt$(3) = "             51 Monroe Street"
   ZOutTxt$(4) = "             Plaza East Two"
   ZOutTxt$(5) = "             Rockville, Maryland 20850"
   ZOutTxt$(6) = ""
   ZOutTxt$(7) = "You are free to copy/share RBBS-PC 17.5 provided"
   ZOutTxt$(08)= "  1.  This program is distributed unmodified"
   ZOutTxt$(09)= "  2.  No fee or consideration is charged for RBBS-PC itself"
   ZOutTxt$(10)= "  3.  This notice is not bypassed or removed."
   CLS
   KEY OFF
   LOCATE ,,0
   ZWasA = ZSnoop
   ZSnoop = -1
   CALL LPrnt(SPACE$(60) + "tm",1)
   CALL LPrnt(SPACE$(16) + STRING$(15,205) + " U S E R W A R E " + STRING$(15,205),1)
   CALL SkipLine(1)
   CALL LPrnt(SPACE$(17) + "Capital PC User Group User-Supported Software",1)
   CALL SkipLine (1)
   CALL LPrnt(SPACE$(5) + CHR$(214) + STRING$(66,196) + CHR$(183),1)
   FOR WasI = 1 TO 10
      CALL LPrnt(SPACE$(5) + CHR$(186) + "    " + ZOutTxt$(WasI) + SPACE$(62 - LEN(ZOutTxt$(WasI))) + CHR$(186),1)
   NEXT
   CALL LPrnt(SPACE$(5) + CHR$(211) + STRING$(66,196) + CHR$(189),1)
   CALL LPrnt(SPACE$(5) + "Copyright (c) 1983-94 Tom Mack, 39 Cranbury Drive, Trumbull, CT 06611",1)
   CALL DelayTime (ZCopyrightSecs)
   ZSnoop = ZWasA
   END SUB
'
101 ' $SUBTITLE: 'GetCommand - sub to get command from command line'
' $PAGE
'
'  NAME    -- GetCommand
'
'  INPUTS  --     PARAMETER                    MEANING
'             ZConfigFileName$     NAME OF RBBS-PC ".DEF" FILE TO
'                                  USE AS A MODEL WHEN CREATING THE
'                                  .DEF FILE NAME TO BE USED BY THIS
'                                  COPY OF RBBS-PC.
'
'             COMMAND LINE         COMMAND LINE USED TO INVOKE
'                                  RBBS-PC IN THE FORM:
'
'       RBBS-PC.EXE x filename DEBUG /time /baud reliable  /cbaud
'
'   WHERE THE OPTIONAL PARAMETERS ARE:
'
'  x       IS THE NODE ID IN THE RANGE 1-9,0,A-Z
' filename IS THE FULLY QUALIFIED FILE NAME TO USE AS THE ".DEF" FILE
' DEBUG    IS A DEBUGGING SWITCH
'
'        Arguments passed from frontend programs, such as Binkley
'        Front Door, and others
'
' /time   or /T:time  is the time to the next event (in minutes)
' /baud   or /B:baud  is the speed of the computer-to-modem link rate
'                     in BPS.  ( AKA Locked rate )
' reliable or /R:reliable  is extended information reported by the
'                            answering modem to indicate reliable connection
' /cbaud  or /C:cbaud is the callers connect rate reported by the answering
'                     modem
'
'  The /?: switches may be in any order following the definition file
'  Otherwise, the switches must be in the correct default RBBS order.
'
'
'
' IF NO PARAMETERS ARE SUPPLIED, RBBS-PC ASSUMES THAT THE .DEF FILE NAME IS
' RBBS-PC.DEF AND THAT THE NODE IS NODE 1.
'
'  OUTPUTS -- ZConfigFileName$     NAME OF RBBS-PC ".DEF" FILE FOR
'                                  THIS COPY OF RBBS-PC TO USE
'             ZNodeRecIndex        RECORD NUMBER WITHIN THE
'                                  MESSAGES FILE FOR THIS "NODE"
'                                  (RANGE IS 2 TO 36)
'
'  PURPOSE --  To get node id from command line and determine if rbbs
'              is being run as a door
'
      SUB GetCommand (PassedDebug,NetTime$,NetBaud$,NetReliable$) STATIC
      STATIC ZDebug
'
'
' *  Skip to node ID checking if there are no passed arguments
'
'
      WasPM$ = COMMAND$
      CALL AllCaps(WasPM$)
      IF INSTR(WasPM$,"/") = 0 THEN _
         GOTO 104
'
'
' * Parse the command line for passed arguments
'
'
      CmdLine$ = MID$(WasPM$,INSTR(WasPM$,"/"))
      WasPM$ = LEFT$(WasPM$,INSTR(WasPM$,"/") - 1)

'
' Here is the command line switches for frontends
' The switches are /T:time /B:baud /R:reliable /C:cbaud and
' they may be in any order following the def filename
'
' If we don't find a key colon we will skip to the
' positional command switches

      IF INSTR(CmdLine$,":") < 3 THEN _
	 GOTO 102
' get the time (in minutes) till next event
      IF INSTR(CmdLine$, "/T:") > 0 THEN
	 NetTime$ = MID$(CmdLine$,INSTR(CmdLine$,"/T:")+3)
	 IF INSTR(NetTime$, "/") > 0 THEN _
	    NetTime$ = LEFT$(NetTime$,INSTR(NetTime$,"/") - 1)
      END IF
' get the terminal bps rate
      IF INSTR(CmdLine$, "/B:") > 0 THEN
	 NetBaud$ = MID$(CmdLine$,INSTR(CmdLine$,"/B:")+3)
	 IF INSTR(NetBaud$, "/") > 0 THEN _
	    NetBaud$ = LEFT$(NetBaud$,INSTR(NetBaud$,"/") - 1)
      END IF
' get the callers bps rate
      IF INSTR(CmdLine$, "/C:") > 0 THEN
	 ZCBaud$ = MID$(CmdLine$,INSTR(CmdLine$,"/C:")+3)
	 IF INSTR(ZCBaud$, "/") > 0 THEN _
	    ZCBaud$ = LEFT$(ZCBaud$,INSTR(ZCBaud$,"/") - 1)
      END IF
' get the reliable mode string
      IF INSTR(CmdLine$, "/R:") > 0 THEN
	 NetReliable$ = MID$(CmdLine$, INSTR(CmdLine$, "/R:") + 3)
	 IF LEFT$(NetReliable$, 1) = " " THEN _
	    NetReliable$ = "" : _
	    GOTO 103
	 IF LEFT$(NetReliable$, 1) = "/" THEN _
	    IF INSTR(NetReliable$, " ") > 0 THEN _
	       NetReliable$ = MID$(NetReliable$, 1, INSTR(NetReliable$, " "))
      END IF
      GOTO 103
102   ' Here are the positional switches
      ZWasA = 0
      FOR WasX = 1 TO LEN(CmdLine$)
          IF MID$(CmdLine$,WasX,1) = "/" THEN _
             ZWasA = ZWasA + 1 : _
             ZSubDir$(ZWasA) = "" _
          ELSE ZSubDir$(ZWasA) = ZSubDir$(ZWasA) + MID$(CmdLine$,WasX,1)
      NEXT
      NetTime$ = ZSubDir$(1)
      IF ZWasA > 1 THEN _
         NetBaud$ = ZSubDir$(2)
      IF ZWasA > 2 THEN _
         NetReliable$ = ZSubDir$(3)
      IF ZWasA > 3 THEN _
         ZCBaud$ = STR$(VAL(ZSubDir$(ZWasA)))
103   CALL Trim(NetTime$)
      CALL Trim(NetBaud$)
      CALL Trim(NetReliable$)
      CALL Trim (ZCBaud$)
104   ZWasA = INSTR(WasPM$,"DEBUG")
      IF ZWasA > 0 THEN _
         ZDebug = -1 : _
         WasPM$ = LEFT$(WasPM$,ZWasA - 1) + _
               RIGHT$(WasPM$,LEN(WasPM$) - ZWasA - 4)
      PassedDebug = ZDebug
      ZWasA = INSTR(WasPM$,"LOCAL")
      IF ZWasA > 0 THEN _
         ZComPort$ = "COM0" : _
         WasPM$ = LEFT$(WasPM$,ZWasA - 1) + _
               RIGHT$(WasPM$,LEN(WasPM$) - ZWasA - 4)
      CALL CheckInt (WasPM$)
      ZNodeRecIndex = ZTestedIntValue + 1
      IF ZNodeRecIndex < 2 THEN _
         ZNodeRecIndex = 2
      ZNodeID$ = LEFT$(MID$(STR$(ZNodeRecIndex-1),2),4)
      ZNodeFileID$ = ZNodeID$
      IF LEN(WasPM$) > 4 AND MID$(WasPM$,2,1) = " " THEN _
         ZConfigFileName$ = MID$(WasPM$,3)_
      ELSE IF ZTestedIntValue > 0 THEN _
         ZConfigFileName$ = "RBBS" + ZNodeFileID$ + ".DEF"
      ZOrigCnfg$ = ZConfigFileName$
      END SUB
'
105 ' $SUBTITLE: 'Trim - sub to eliminate leading/trailing blanks'
' $PAGE
'
'  NAME    -- Trim
'
'  INPUTS  --  PARAMETER                    MEANING
'              TrimParm$           STRING THAT IS TO HAVE LEADING
'                                  AND TRAILING BLANKS ELIMINATED FROM
'
'  OUTPUTS --  TrimParm$           STRING WITH NO LEADING OR TRAILING
'                                  BLANKS
'
'  PURPOSE --  To strip leading and trailing blanks
'
      SUB Trim (TrimParm$) STATIC
      TrimParm$ = LTRIM$(RTRIM$(TrimParm$))
      END SUB
'
107 '  $SUBTITLE: 'TrimTrail - sub to trim off trailing characters'
'  $PAGE
'
'  NAME    --  TrimTrail
'
'  INPUTS  --  PARAMETER            MEANING
'              TrimParm$       WHAT STRING TO TRIM FROM
'              TrimThis$       WHAT CHARACTER TO TRIM OFF END
'
'  OUTPUTS --  NONE
'
'  PURPOSE --  To remove all occurences of a character from end of string
'
      SUB TrimTrail (TrimParm$,TrimThis$)
      IF RIGHT$(TrimParm$, 1) <> TrimThis$ THEN _
         EXIT SUB
      WasJ = LEN(TrimParm$) - 1
108   IF WasJ > 0 THEN _
         IF MID$(TrimParm$, WasJ, 1) = TrimThis$ THEN _
            WasJ = WasJ - 1 : _
            GOTO 108
      TrimParm$ = LEFT$(TrimParm$, WasJ)
      END SUB
'
109 '  $SUBTITLE: 'VarInit - subroutine to initialize system variables'
'  $PAGE
'
'  NAME    --  VarInit
'
'  INPUTS  --  PARAMETER           MEANING
'              NONE
'
'  OUTPUTS --  NONE
'
'  PURPOSE --  To initialize system variable
'
    SUB VarInit
    DEF SEG                            ' Point to BASIC
    WIDTH 80                           ' Set Screen Width
    KEY OFF                            ' Line 25 turned off
' ********************* Variable Definitions *******************************
    ZAcknowledge$ = CHR$(6)
    ZAckChar$ = "C" + _
            ZAcknowledge$
    ZActiveMenu$ = "B"
    ZActiveMessage$ = CHR$(225)
    ZBackSpace$ = CHR$(8) + _
                 CHR$(32) + _
                 CHR$(8)
    ZBackArrow$ = CHR$(29) + _
                  CHR$(32) + _
                  CHR$(29)
    ZBaudRates$ = "      300  450 1200 2400 4800 7200 960012000144001680019200216002400026400288003840057600"
    ZBellRinger$ = CHR$(7)
    ZBulletinMenu$ = ""
    ZWasCL = 24
    ZCancel$ = CHR$(24)
    ZColorReset$ = CHR$(27) + _
                   "[00;37;40m"
    ZConfigFileName$ = "RBBS-PC.DEF"
    ZCarriageReturn$ = CHR$(13)
    ZDeletedMsg$ = CHR$(226)
    ZEndTransmission$ = CHR$(4)
    ZEscape$ = CHR$(27)
    ZExpectActiveModem = 0
    ZFalse = 0
    ZF1Key = 59
    ZF10Key = 68
    ZConfName$ = "MAIN"
    CALL SetHiLite (ZTrue)
    ZHomeConf$ = ""
    ZInConfMenu = -1
    ZLastCommand$ = "M "
    ZLimitMinsPerSession = 0
    ZLineFeed$ = CHR$(10)
    ZLineFeeds = NOT ZFalse
    ZLineEditChk$ = CHR$(9) + _
                    ZLineFeed$ + _
                    CHR$(11) + _
                    CHR$(12) + _
                    CHR$(127) + _
                    CHR$(8) + _
                    ZBellRinger$ + _
                    CHR$(26) + _
                    CHR$(227)
    ZLineMes$ = SPACE$(78)          ' fixed length string workspace
    ZLockStatus$ = "UM UU UB UD"
    ZMenuIndex = 2
    ZNAK$ = CHR$(21)
    ZNoAdvance = ZFalse
    ZPageLength = 23
    ZParseOff = ZFalse
    ZPressEnter$ = " (Press [ENTER] to quit)"
    ZPressEnterExpert$ = " ([ENTER] quits)"
    ZPressEnterNovice$ = ZPressEnter$
    ZPrivateDoor = ZFalse
    ZRightMargin = 72
    ZReturnLineFeed$ = ZCarriageReturn$ + _
                        ZLineFeed$
    ZSmartTable$ = "CS PB NS FN LN SL DT TM TR TE " + _
                   "TL RP RR CT C1 C2 C3 C4 C5 C6 " + _
                   "C7 C8 C0 DD BD DB UB DL UL FI " + _
                   "VY VN TY TN BN ND FS LS CN DC " + _
                   "C9 CA CB CC CD CE CF G0 G1 G2 " + _
                   "G3 G4 G5 G6 G7 FD FH FC LT BA " + _
                   "BT TP CG"
    ZStartOfHeader$ = CHR$(1)
    ZTimeLoggedOn$ = SPACE$(8)
    ZTrue = NOT ZFalse
    ZUpInc = -1
    ZXOff$ = CHR$(19)
    ZXOn$ = CHR$(17)
    ZInterrupOn$ = CHR$(11) + ZCancel$ + ZXOff$ + ZXOn$ + ZCarriageReturn$
    ZOptionEnd$ = ZReturnLineFeed$ + " ,("
    ZCrLf$ = ZCarriageReturn$ + ZLineFeed$
    ZVersionID$ = "17.5  - 02/20/95"
    ZVersionID2$ = " w/Full Screen ANSI Editor " + ZCrLf$ + _
             "       - Batch File Transfers, WildCard Downloads," + ZCrLf$ + _
             "       - Mark/Download Files by Number, & 99 Node Support"
    ZWasLG$(1) = "Registration Check Failed"
    ZWasLG$(2) = "Sysop name attempted"
    ZWasLG$(3) = "Locked out attempt"
    ZWasLG$(4) = "Password Attempt Failed"
    ZWasLG$(5) = "Auto Lockout done"
    ZWasLG$(6) = "Name in use on another Node!"
    ZWasLG$(7) = ""
    ZWasLG$(8) = "Locked reason read!"
    ZWasLG$(9) = "Expired Registration"
    CALL GetCommand (ZDebug,ZNetTime$,ZNetBaud$,ZNetReliable$)
    ZSubParm = 1
    CALL ReadDef (ZConfigFileName$)
    ZUseTPut = (ZUpperCase OR ZXOnXOff)
    ZOrigCallers$ = ZCallersFile$
    ZOrigMsgFile$ = ZMainMsgFile$
    ZOrigUserFile$ = ZMainUserFile$
    ZOrigSysopFN$ = ZSysopFirstName$
    ZOrigSysopLN$ = ZSysopLastName$
    ZPromptBell = ZPromptBellDef
    ZSecretName$ = ZSysopPswd1$ + " " + ZSysopPswd2$
    ZDropChange = ZFalse
    ZANSITest = ZFalse
    ZRIPTest = ZFalse
    ZNetConference = ZFalse
    ZRIPReset$ = "!|*!|0000270P01"
    ZAllowInternodeChat = ZFalse
'    ChatFileName$ = ENVIRON$ ("RCHAT")
'    CALL AllCaps (ChatFileName$)
'    IF ChatFileName$ = "" THEN _
'       ChatFileName$ = ZDiskForDos$
'    IF RIGHT$(ChatFileName$,1) = "\" THEN _
'       ChatFileName$ = LEFT$(ChatFileName$,LEN(ChatFileName$) - 1)
'    ChatFileName$ = ChatFileName$ + "\RBBSCHAT.DEF"
    ZTimeBankInActive = ZFalse
    ZAutoLogoffSecTime! = 20
    ZOnlyOneTimeLockPerDay = ZFalse
    ZUseCDWorkDrive = ZFalse
    END SUB
'
112 ' $SUBTITLE: 'SysMenu - sub to display RBBS-PC SYSOP menu'
'  $PAGE
'
'  NAME    --  SysMenu
'
'  INPUTS  --  PARAMETER           MEANING
'
'  OUTPUTS --  NONE
'
'  PURPOSE --  TO DISPLAY RBBS-PC's SYSOP MENU ON THE LOCAL SCREEN
'
    SUB SysMenu STATIC
    ZLocalUser = ZTrue
    ZSnoop = ZTrue
    ZNonStop = ZTrue
    CALL CheckTime (TIMER, ZDelay!, 1)
    CLS
    ZStopInterrupts = ZTrue
    ZBypassTimeCheck = ZTrue
    CALL BufFile ("MENU0",WasX,ZFalse)
    ZNonStop = ZFalse
    ZBypassTimeCheck = ZFalse
    ZLocalUser = ZFalse
    IF NOT ZOK THEN _
       CALL LPrnt("MENU0 not on default drive",1)
    LOCATE 2,14
    IF ZDosANSI THEN _
       CALL LPrnt(ZEscape$ + "[1m" + ZVersionID$,0) _
    ELSE _
       CALL LPrnt(ZVersionID$,0)
    LOCATE 2,40
    CALL LPrnt(ZNodeID$,0)
    LOCATE 2,59
    WasX$ = DATE$
    CALL LPrnt(LEFT$(WasX$,6) + RIGHT$(WasX$,2),0)
    LOCATE 2,71
    CALL LPrnt(LEFT$(TIME$,5),0)
    CALL GetLC
    LOCATE 4,2
    CALL LPrnt ("Last Caller: " + ZLastCaller$,0)
    IF ZFMSDirectory$ <> "" THEN _
       LOCATE 7,27 : _
       CALL LPrnt("YES",0)
    IF ZExtendedLogging THEN _
       LOCATE 8,27 : _
       CALL LPrnt("YES",0)
    IF ZFossil THEN _
       LOCATE 9,27 : _
       CALL LPrnt("YES",0)
    LOCATE 10,26 : _
    CALL LPrnt(ZComPort$,0)
    LOCATE 11,26
    CALL LPrnt (STR$(CINT(FRE("A")/1024)) + "k",0)
    IF ZDebug THEN _
       LOCATE 12,27 : _
       CALL LPrnt("Yes",0)
    LOCATE 15,20
    CALL LPrnt (ZMenuNewDate$,0)
    LOCATE 15,32
    CALL LPrnt (ZMenuNewTime$,0)
    LOCATE 16,14
    CALL LPrnt (STR$(ZMenuNewCalls),0)
    LOCATE 16,33
    CALL LPrnt (STR$(ZMenuNewUpld),0)
    LOCATE 17,14
    CALL LPrnt (STR$(ZMenuNewUsers),0)
    LOCATE 17,33
    CALL LPrnt (STR$(ZMenuNewSysop),0)
    END SUB
'
120 '  $SUBTITLE: 'EditDef - sub to edit config parameters'
'  $PAGE
'
'  NAME    -- EditDef
'
'  INPUTS  --     PARAMETER                    MEANING
'
'  OUTPUTS --                            OUTPUT STRING
'
'  PURPOSE -- Interprets and adjusts stored configuration parameters
'
      SUB EditDef STATIC
      IF ZNetworkType = 1 THEN _
         ZNetworkType = 6
      ZMinsPerSessionDef = ZMinsPerSession
      ZAllOpts$ = ZMainCmds$ + _
                  ZFileCmd$ + _
                  ZUtilCmds$ + _
                  ZLibCmds$ + _
                  ZGlobalCmnds$ + _
                  ZSysopCmds$
      ZHelpExtension$ = "." + _
                        ZHelpExtension$
      ZCompressedExt$ = ZDefaultExtension$
      ZWasQ = INSTR(ZDefaultExtension$,".")
      IF ZWasQ > 0 THEN _
         ZDefaultExtension$ = LEFT$(ZDefaultExtension$, ZWasQ-1)
      ZCurDirPath$ = ZDirPath$
      ZTempExpiredSec = ZExpiredSec
      ZBegMain = 1
      ZBegFile = LEN(ZMainCmds$) + ZBegMain
      ZBegUtil = LEN(ZFileCmd$) + ZBegFile
      ZBegLibrary = LEN(ZUtilCmds$) + ZBegUtil
      ZHelp$(3) = ZHelpPath$ + _
                 ZHelp$(3)
      ZHelp$(4) = ZHelpPath$ + _
                 ZHelp$(4)
      ZHelp$(7) = ZHelpPath$ + _
                 ZHelp$(7)
      ZHelp$(9) = ZHelpPath$ + _
                 ZHelp$(9)
      CALL BreakFileName (ZWelcomeFile$,ZWelcomeFileDrvPath$,Prefix$,_
                     Extension$,ZTrue)
     CALL ASCIICodes ("[","]",ZDefaultLineACK$)
     CALL ASCIICodes ("[","]",ZHostEchoOn$)
     CALL ASCIICodes ("[","]",ZHostEchoOff$)
     CALL ASCIICodes ("[","]",ZEmphasizeOffDef$)
     CALL ASCIICodes ("[","]",ZEmphasizeOnDef$)
     ZDR1$ = ZFG1Def$
     ZDR2$ = ZFG2Def$
     ZDR3$ = ZFG3Def$
     ZDR4$ = ZFG4Def$
     ZDR5$ = ZFG5Def$
     ZFileColor1$ = ZFG1Def$
     ZFileColor2$ = ZFG2Def$
     ZFileColor3$ = ZFG3Def$
     ZFileColor4$ = ZFG4Def$
     ZFileColor5$ = ZFG5Def$
     IF ZSubParm = -62 THEN _
        EXIT SUB
     ZLocalUserMode = (RIGHT$(ZComPort$,1) < "1")
     IF ZLocalUserMode THEN _
        ZRecycleToDos = ZTrue
     ZEchoer$ = ZDefaultEchoer$
     IF LEN(ZScreenOutMsg$) < 2 THEN _
        ZScreenOutMsg$ = ZStartOfHeader$
     ZSmartTextCode$ = CHR$(ZSmartTextCode)
     IF ZMaxWorkVar < 13 THEN _
        ZMaxWorkVar = 13
'
' ***  ESTABLISH RBBS-PC'S DOS SUBDIRECTORIES USAGE  ***
'
    IF ZMainFMSDir$ <> "" THEN _
       ZFMSDirectory$ = ZDirPath$ + _
                        ZMainFMSDir$ + _
                        "." + _
                        ZMainDirExtension$ : _
       ZActiveFMSDir$ = ZFMSDirectory$ : _
       ZLibDir$ = ZLibDirPath$ + _
                            ZMainFMSDir$ + _
                            "." + _
                            ZLibDirExtension$
    ZUpcatHelp$ = ZHelpPath$ + _
                  ZUpcatHelp$ + _
                  ZHelpExtension$
    IF ZSubDirCount < 1 THEN _
       GOTO 123
    FOR ZSubDirIndex = 1 TO ZSubDirCount
       INPUT #2,ZSubDir$
       IF RIGHT$(ZSubDir$,1) <> "\" THEN _
         ZSubDir$(ZSubDirIndex) = ZSubDir$ + _
                                 "\" _
       ELSE ZSubDir$(ZSubDirIndex) = ZSubDir$
    NEXT
    GOTO 125
123 FOR ZSubDirIndex = 1 TO LEN(ZDnldDrives$) - 1
       ZSubDir$(ZSubDirIndex) = MID$(ZDnldDrives$,ZSubDirIndex,1) + _
                               ":"
    NEXT
    ZSubDirCount = LEN(ZDnldDrives$) - 1
'
' *****  SETUP UPLOAD DRIVE AND DIRECTORY.NAME  ***
'
125 ZUpldDirCheck$ = ZUpldDir$
    ZSubDirCount = ZSubDirCount + 1
    IF ZUpldToSubdir THEN _
       ZSubDir$(ZSubDirCount) = ZUpldSubdir$ + _
                               "\" _
    ELSE ZSubDir$(ZSubDirCount) = RIGHT$(ZDnldDrives$,1) + _
                                 ":"
    ZUpldDir$ = ZUpldDir$ + _
                        "." + _
                        ZMainDirExtension$
    CALL SearchArray (ZSubDir$(ZSubDirCount),ZSubDir$(),ZSubDirCount-1,Found)
    ZCanDnldFromUp = (Found > 0)
    ZUpldDir$ = ZUpldPath$ + _
                        ZUpldDir$
126 CLOSE #2
    ZSubParm = -10
    CALL Carrier
'
' ***  INITIALIZE OMNINET INTERFACE IF OMNINET IN USE  ***
'
128 IF ZNetworkType = 2 THEN _
       ZWasCN$ = SPACE$(535) : _
       CALL InitIO(ZWasA)
       END SUB
'
129 '  $SUBTITLE: 'ASCIICodes - subrotuine to allow any ASCII codes'
'  $PAGE
'
'  NAME    -- ASCIICodes
'
'  INPUTS  --     PARAMETER                    MEANING
'                 LeftParen$           MARKS BEGINNING OF #
'                 RightParen$          MARKS END OF #
'                 Strng$               INPUT STRING
'
'  OUTPUTS --    Strng$                OUTPUT STRING
'
'  PURPOSE -- To allow a config string to have any ascii values.
'             characters not enclosed taken as is.  Enclosed
'             characters interpreted as value of ascii code.
'             (e.g. "123[32]4" is interpreted as "123 4").
'
    SUB ASCIICodes (LeftParen$,RightParen$,Strng$) STATIC
    IF LEN(Strng$) < 1 THEN _
       EXIT SUB
    Start = 1
    WasL = LEN(Strng$)
    ZUserIn$ = Strng$ + _
         LeftParen$
    WasX = INSTR(ZUserIn$,LeftParen$)
    NewString$ = ""
    WHILE Start <= WasL
       NewString$ = NewString$ + _
                    MID$(ZUserIn$,Start,WasX - Start)
       WasY = INSTR(WasX,ZUserIn$,RightParen$)
       IF WasY > 0 THEN _
          WasK = VAL(MID$(ZUserIn$,WasX + 1,WasY - WasX - 1)) : _
          NewString$ = NewString$ + _
                       CHR$(WasK) : _
          Start = WasY + 1 _
       ELSE NewString$ = NewString$ + _
                         MID$(ZUserIn$,WasX,WasL + 1 - WasX) : _
            Start = WasL + 1
       WasX = INSTR(Start,ZUserIn$,LeftParen$)
    WEND
    Strng$ = NewString$
    END SUB
'
200 ' $SUBTITLE: 'AnswerIt - sub to establish connection'
' $PAGE
'
'  NAME    -- AnswerIt
'
'  INPUTS  --     PARAMETER                    MEANING
'                 ZSubParm = 1           WAIT FOR PHONE TO RING
'                          = 2           CONTINUE LOOKING FOR CONNECT
'                          = 3           REENTRY AFTER FUNCTION KEY
'                          = 4           GO ON LINE IMMEDIATELY
'                 ZBG                    LOCAL DISPLAY'S BACKGROUND
'                 ZBorder                LOCAL DISPLAY'S BORDER COLOR
'                 ZComPort$              COMMUNICATIONS PORT NAME
'                 ZComputerType          TYPE OF COMPUTER RUNNING ON
'                 ZDumbModem             NON-HAYES TYPE MODEM FLAG
'                 ZExtendedLogging       EXTENDED CALLERS LOG FLAG
'                 ZFG                    LOCAL DISPLAY'S FOREGROUND
'                 ZModemAnswerCmd$       COMMAND TO ANSWER PHONE
'                 ZModemCntlReg          LOCATION OF MODEM CNTRL. REG
'                 ZModemCountRingsCmd$   COMMAND TO COUNT PHONE RINGS
'                 ZModemInitBaud$        BAUD AT WHICH TO OPEN COMM.
'                 ZModemResetCmd$        COMMAND TO RESET THE MODEM
'                 ZModemStatusReg        LOCATION OF MODEM STATUS REG
'                 ZPrinter               FLAG TO PRINT ON LOCAL PRT.
'                 ZRequiredRings         NUMBER OF RINGS TO ANSWER ON
'                 ZSnoop                 FLAG TO DISPLAY ON LOCAL PC
'                 ZSysopNext             FLAG TO GIVE SYSOP CONTROL
'
'  OUTPUTSS --    BaudTest!              BAUD RATE TO SET RS232 AT
'                 ZEightBit              PARITY INDICATOR
'                 ZReliableMode          INDICATES MODEM-SUPPLIED
'                                        "ERROR-FREE" Protocol ACTIVE
'                 ZSubParm          = 1  CARRIER DETECT FOUND (I.E.
'                                        MODEM AUTO-ANSWERED).
'                                   = 2  ANSWERED THE PHONE AND
'                                        CARRIER DETECT OCCURRED.
'                                   = 3  SYSOP HIT "ESC" KEY ON THE
'                                        LOCAL KEYBOARD.
'                                   = 4  ANSWERED THE PHONE BUT NO
'                                        CARRIER WAS DETECTED.
'                                   = 5  COMM. BUFFER OVERFLOW.
'                                   = 6  FUNCTION KEY PRESSED ON THE
'                                        LOCAL KEYBOARD.
'
'  PURPOSE -- To detect incoming call and establish connection.
'
      SUB AnswerIt STATIC
'      IF (NOT ZExitToDoors) AND (NOT ZSubBoard) THEN _              ' 175-1221
'         CALL GetMenuNew                                            ' 175-1221
      ZErrCode = 0
      ZReliableMode = ZFalse
      ZFF = ZSubParm
      ZSubParm = 0
      ON ZFF GOTO 201,324,245,320
'
'
' *  INITIALIZE MODEM AND ANNOUNCE RBBS-PC IS UP AND READY FOR CALLS
'
'
201 ZSubParm = -10
    CALL Carrier
    IF ZSubParm = 0 THEN _
       GOTO 210
'
'
' *  RESET THE MODEM VIA THE MODEM CONTROL REGISTER  TO ASSURE IT IS READY
'
'
    IF ZFossil THEN _
       State = 0 : _
       CALL FosDTR(ZComPort,State) _
    ELSE OUT ZModemCntlReg,&H4
    CALL DelayTime (ZModemInitWaitTime)
'
'
' *  CLEAR THE MODEM CONTROL REGISTER PRIOR TO OPEN THE COMMUNICATIONS PORT
'
'
    IF ZFossil THEN _
       State = 1 : _
       CALL FosDTR(ZComPort,State) _
    ELSE OUT ZModemCntlReg,&H0
    CALL DelayTime (ZModemInitWaitTime)
210 IF ZPrivateDoor THEN _
       CALL Transfer : _
       GOTO 235
    CALL OpenCom(ZModemInitBaud$,",N,8,1")
220 CALL AMorPM
230 CALL Printit (" RBBS-PC " + ZVersionID$ + " Node " + _
                    ZNodeID$ + " up " + ZTime$ + " on " + DATE$)
235 ZEightBit = ZTrue
    IF ZExitToDoors THEN _
       CALL ReadProf
    ZSubParm = -10
    CALL Carrier
    IF ZSubParm = 0 AND _
       ZExitToDoors THEN _
       ZSubParm = 1 : _
       GOTO 335
    IF ZSubParm = 0 AND _
       ZExpectActiveModem THEN _
       ZBaudTest! = VAL(ZNetBaud$) : _
       CALL TestRel (ZNetReliable$) : _
       GOTO 328
    IF ZExpectActiveModem OR _
       ZExitToDoors THEN _
       ZSubParm = 4 : _
       ZExitToDoors = ZFalse : _
       EXIT SUB
    IF ZSubParm = 0 THEN _
       ConnectDelay! = TIMER + ZMaxCarrierWait : _
       GOTO 324
    CALL GetMenuNew                                            ' 175-1221
    CALL SysMenu
    CALL ModemPut (ZModemResetCmd$)
    CALL DelayTime (ZModemInitWaitTime)
    CALL ModemPut (ZModemInitCmd$)
    RingBack = ZFalse
    LOCATE 20,23
    IF ZRequiredRings = 0 THEN _
       CALL LPrnt("WAITING FOR CARRIER",0) : _
       GOTO 237
    IF MID$(ZModemInitCmd$, _
          INSTR(ZModemInitCmd$,"S0") + 3,3) = "255" THEN _
       CALL LPrnt("RING BACK SYSTEM",0) : _
       RingBack = ZTrue : _
       GOTO 236
    CALL LPrnt("WAITING FOR RING ",0)
236 LOCATE 20,40 : _
    CALL LPrnt(MID$(STR$(ZRequiredRings),2),0)
237 LOCATE 19,23
    IF ZDosANSI THEN _
       CALL LPrnt(ZEscape$ + "[05m" + "YES" + ZEscape$ + "[00m",0) _
    ELSE CALL LPrnt ("YES",0)
    COLOR ZFG,ZBG,ZBorder
    LOCATE 21,23
'
'
' *  GET READY TO ANSWER INCOMING CALL:
' *       1.  LET THE MODEM "AUTO-ANSWER" FOR RBBS-PC.
' *           REQUIRED RINGS = 0 AND S0 = 1 IN MODEM INIT COMMAND.
' *       2.  ANSWER THE MODEM ON A SPECIFIED NUMBER OF RINGS.
' *           REQUIRED RINGS > 0 AND S0 = 254 IN MODEM Init COMMAND.
' *       3.  ANSWER THE MODEM ON A SPECIFIED NUMBER OF RINGS AFTER A USER
' *           First CALLS AND THEN HANGS UP (I.E. RING-BACK).
' *           REQUIRED RINGS > 0 AND S0 = 255 IN MODEM INIT COMMAND.
'
'
    WasQQ = 255
    WasI = INSTR(ZModemInitCmd$,"S0")
    IF WasI = 0 THEN _
       GOTO 239
    Sreg = VAL(MID$(ZModemInitCmd$,WasI + 3,3))
    IF Sreg = 255 THEN
       WasQQ = 0 : _
       ZBlk = WasQQ
    END IF
    ZSecsUsedSession! = TIMER
    ZSubParm = 1
    CALL Line25
    RingAnswer = ZTrue
    IF RingBack THEN _
       RingAnswer = ZFalse
239 RingBackWaitStart! = 0
    IF RingBack THEN _
       RingBackWaitStart! = TIMER : _
       COLOR 7,0,0 _
    ELSE COLOR ZFG,ZBG,ZBorder
240 IF ZSysopNext THEN _
       ZSubParm = 3 : _
       EXIT SUB
'
'
' * WAIT FOR INCOMING CALLS
'
'
    ScreenCleared = ZFalse
245 InactiveDelay! = TIMER + (60 * ZRecycleWait)
    NoCall = ZTrue
    CALL FlushCom (ModemResponse$)
    ModemResponse$ = ""
247 IF INP(ZModemStatusReg) > 127 OR (NOT NoCall) THEN _
       GOTO 274
       CALL FindFKey
       IF ZSubParm < 0 THEN _
          EXIT SUB
250    IF ZKeyPressed$ = ZEscape$ THEN _
          ZSubParm = 3 : _
          EXIT SUB
       IF ZKeyPressed$ <> "" THEN _
          GOTO 235
260    IF RingBackWaitStart! > 0 THEN _
          CALL CheckTime(RingBackWaitStart!, TempElapsed!, 2) : _
          IF TempElapsed! > 45 THEN _
             RingBackWaitStart! = 0 : _
             RingBackCount = 0 : _
             RingAnswer = ZFalse: _
             IF RingBack THEN _
               LOCATE 21,23 : _
               CALL LPrnt("Ringback timeout" + ZPagingPtrSupport$,1)
265    CALL CheckTime(ZSecsUsedSession!, TempElapsed!, 2)
       IF TempElapsed! > 120 AND NOT ScreenCleared THEN _
          LOCATE ,,0 : _
          CLS : _
          ZWasCL = 1 : _
          ScreenCleared = ZTrue : _
          ZSecsUsedSession! = TIMER
       IF ZTimeToDropToDos! > 0 THEN _
          IF ZOldDate$ <> DATE$ THEN _
          IF TIMER => ZTimeToDropToDos! AND _
             TIMER < 86340 THEN _                    ' Skip btw 23:59 and 00:00
                ZSubParm = 7 : _
                EXIT SUB
266    IF (INP(ZModemStatusReg) AND &H40) > 0 AND _
          ZRequiredRings > 0 THEN
             IF Sreg = 252 OR Sreg = 253 THEN
                PAnswer = 0
                CALL PersonalRing(PAnswer, Sreg)
                IF PAnswer = 1 THEN
                   GOTO 276
                END IF
             ELSE
                GOTO 276
             END IF
       END IF
270    IF ZRecycleWait > 0 THEN _
          CALL CheckTime(InactiveDelay!, TempElapsed!, 1) : _
          IF TempElapsed! <= 0 THEN _
             ZSubParm = 8 : _
             EXIT SUB
       IF Sreg = 252 OR Sreg = 253 THEN
          IF PAnswer = 0 THEN
             CALL GoIdle
             GOTO 247
          ELSE
             GOTO 276
          END IF
       END IF
       CALL FlushCom (WasX$)
       IF LEN(WasX$) > 0 THEN _
          ModemResponse$ = ModemResponse$ + WasX$ : _
          RingDetected = (INSTR(ModemResponse$,"RING") > 0) : _
          ConnectDetected = (INSTR(ModemResponse$,"ONNECT") > 0) : _
          NoCall = (NOT RingDetected) AND (NOT ConnectDetected)
    IF RingDetected AND ZRequiredRings > 0 THEN _
       MID$(ModemResponse$, INSTR(ModemResponse$,"RING")+1,1) = "A" : _
       RingDetected = ZFalse : _
       GOTO 276
    CALL GoIdle
    GOTO 247
274 IF NOT RingBack THEN _
       IF ConnectDetected THEN _
          GOTO 321
    IF ZRequiredRings = 0 THEN _
       CALL DelayTime (3) : _
       GOTO 321
'
'
' * PREPARE TO ANSWER THIS CALL ON A SPECIFIED NUMBER OF RINGS (S0 = 254) OR
' * THE CALL AFTER THIS CALL ON A SPECIFIED NUMBER OF RINGS (S0 = 255) --
' * "RING BACK."
'
'
276 CALL EofComm (Char)
    IF Char <> -1 THEN _
       CALL FlushCom(WasX$) : _
       IF ZSubParm = - 1 THEN _
          EXIT SUB
    ZOutTxt$ = ZModemCountRingsCmd$
    CALL ModemPut (ZOutTxt$)
    CALL DelayTime (ZModemCmdDelayTime)
290 CALL FlushCom(WasX$)
    IF ZSubParm = -1 THEN _
       EXIT SUB
291 IF LEN(WasX$) = 0 THEN _
       GOTO 310
292 IF INSTR(WasX$,"0") < 1 THEN _
       GOTO 293
    WasX$ = MID$(WasX$,INSTR(WasX$,"0"),4)
293 IF (NOT RingAnswer) AND (VAL(WasX$) < RingBackCount) THEN _
       RingAnswer = ZTrue
300 RingBackCount = VAL(WasX$)
    ZWasQ = RingBackCount + 1
    IF (NOT RingAnswer) THEN _
       ZWasQ = 0
305 LOCATE 21,23
    IF ZDosANSI THEN _
       CALL LPrnt(ZEscape$ + "[1;40;31m" + TIME$ + " Ring " + _
                  STR$(ZWasQ) + ZEscape$ + "[00m",0) _
    ELSE _
       CALL LPrnt(TIME$ + " Ring " + STR$(ZWasQ),0)
310 IF (RingBackCount + 1 < ZRequiredRings) OR _
       (NOT RingAnswer) THEN _
       GOTO 239
320 CALL ModemPut (ZModemAnswerCmd$)
'
'
' *  TEST FOR CARRIER PRESENT
'
'
321 ConnectDelay! = TIMER + ZMaxCarrierWait
322 CALL CheckTime(ConnectDelay!, TempElapsed!, 1)
323 ZSubParm = -10
    CALL Carrier
    IF ZSubParm AND _
       TempElapsed! > 0 THEN _
       GOTO 322
    IF ZSubParm THEN _
       ZSubParm = 4 : _
       EXIT SUB
    CALL DelayTime (3)
324 ZSubParm = 0
    CALL CheckTime(ConnectDelay!, TempElapsed!, 1)
    IF TempElapsed! <= 0 THEN _
       CALL UpdtCalr ("Connect timeout",1) : _
       ZSubParm = 4 : _
       EXIT SUB
325 CALL FlushCom(WasX$)
    IF ZSubParm = -1 THEN _
       IF ZErrCode = 69 THEN _
          ZSubParm = 5 : _
       EXIT SUB
    ModemResponse$ = ModemResponse$ + WasX$
    IF LEN(ModemResponse$) > 200 THEN _
       ModemResponse$ = RIGHT$(ModemResponse$,20)
    CALL CheckTime(ConnectDelay!, TempElapsed!, 1)
    IF TempElapsed! <= 0 THEN _
       CALL UpdtCalr ("Connect timeout",1) : _
       ZSubParm = 4 : _
       EXIT SUB
    IF ZDumbModem THEN _
       ZBaudTest! = VAL(ZModemInitBaud$) : _
       GOTO 327
    IF INSTR(ModemResponse$,"FAST") THEN _
       ZBaudTest! = 19200 : _
       GOTO 327
    IF INSTR(ModemResponse$,"ONNECT") THEN _
       ZBaudTest! = VAL(MID$(ModemResponse$,INSTR(ModemResponse$,"ONNECT") + 7)) : _
       GOTO 327
    IF INSTR(ModemResponse$,"ONLINE") THEN _
       ZBaudTest! = VAL(MID$(ModemResponse$,INSTR(ModemResponse$,"ONLINE") + 7)) : _
       GOTO 327
    GOTO 324
327 CALL TestRel (ModemResponse$)
328 CALL SetBPS (ZBaudTest!,ZBPS)
    IF ZBPS = 0 THEN GOTO 324
331 CALL SetBaud
    ZSubParm = 2
335 DontWrite = 0
'                 ZSubParm          = 1  CARRIER DETECT FOUND (I.E.
'                                        MODEM AUTO-ANSWERED).
'                                   = 2  ANSWERED THE PHONE AND
'                                        CARRIER DETECT OCCURRED.
'                                   = 3  SYSOP HIT "ESC" KEY ON THE
'                                        LOCAL KEYBOARD.
'                                   = 4  ANSWERED THE PHONE BUT NO
'                                        CARRIER WAS DETECTED.
'                                   = 5  COMM. BUFFER OVERFLOW.
'                                   = 6  FUNCTION KEY PRESSED ON THE
'                                        LOCAL KEYBOARD.
    END SUB
'
336 ' $SUBTITLE: 'TestRel - Test for Reliable mode connection'
' $PAGE
'
'  NAME    -- TestRel
'
'  INPUTS  --     PARAMETER                    MEANING
'                 Strng$                 STRING TO CHECK FOR RELIABLE
'
'  OUTPUTS --    ZReliableMode           RELIABLE MODE INDICATOR
'
'  PURPOSE -- To test for reliable connect
'
    SUB TestRel (Strng$)
    ZReliableMode = ZFalse
    IF Strng$ = "" THEN _
       EXIT SUB
    CALL AllCaps (Strng$)
    IF INSTR(Strng$,"REL") OR _
       INSTR(Strng$,"R C") OR _
       INSTR(Strng$,"ARQ") OR _
       INSTR(Strng$,"LAP") OR _
       INSTR(Strng$,"ECL") OR _
       INSTR(Strng$,"AFT") OR _
       INSTR(UCASE$(Strng$),"V.F") OR _
       INSTR(UCASE$(Strng$),"VFC") OR _
       INSTR(Strng$,"MNP") THEN _
         ZReliableMode = -1
    ZWasZ = INSTR(Strng$,"ARRIER ")
    IF ZWasZ > 0 THEN _
       IF VAL(MID$(Strng$,ZWasZ+6)) > 0 THEN _
          ZCBaud$ = STR$(VAL(MID$(Strng$,ZWasZ+6))) : _
          CALL Trim (ZCBaud$)
    END SUB
'
455 ' $SUBTITLE: 'BadChar - sub to check user names for bad characters'
' $PAGE
'
'  NAME    -- BadChar
'
'  INPUTS  --     PARAMETER                    MEANING
'                 PassedName$                  USER NAME
'
'  OUTPUTS --    PassedName$            USER NAME WILL CONTAIN ""
'                                       IF BAD CHARACTERS FOUND
'
'  PURPOSE -- To check user names for invalid characters
'
    SUB BadChar (PassedName$)
    WasJ = 1
    WasXX = LEN(PassedName$)
457 IF WasJ > WasXX THEN _
       EXIT SUB
    WasX$ = MID$(PassedName$,WasJ,1)
    IF INSTR("ABCDEFGHIJKLMNOPQRSTUVWXYZ '-./0123456789",WasX$) = 0 THEN _
       PassedName$ = "" : _
       EXIT SUB
    WasJ = WasJ + 1
    GOTO 457
    END SUB
'
660 ' $SUBTITLE: 'PassWrd - verify User and Message passwords'
' $PAGE
'
'  NAME    -- PassWrd
'
'  INPUTS  --     PARAMETER                    MEANING
'                 ZSubParm         = 1      VERIFY USER PASSWORD
'                                  = 2      VERIFY MESSAGE PASSWORD
'                                  = 3      VERIFY MESSAGE PASSWORD
'                                  = 4      VERIFY MESSAGE PASSWORD
'                                  = 5      VERIFY MESSAGE PASSWORD
'
'  OUTPUTS -- ZPswdFailed                   SET TO 0 IF PASSED
'                                           SET TO -1 IF FAILED
'
'  PURPOSE -- To verify user and message passwords
'
    SUB PassWrd STATIC
    ZErrCode = 0
    ON ZSubParm GOTO 665,667,670,675,677
665 IF ZPswdSave$ = ZPswd$ THEN _
       ZPswdFailed = 0 : _
       EXIT SUB
667 Attempts = 0
670 Attempts = Attempts + 1
    IF Attempts > ZAttemptsAllowed THEN _
       ZPswdFailed = ZTrue : _
       EXIT SUB
675 ZOutTxt$ = "Enter Password"
    ZHidden = ZTrue
    CALL PopCmdStack
    IF ZSubParm < 0 THEN _
       ZPswdFailed = ZTrue : _
       EXIT SUB
    ZHidden = ZFalse
    ZWasZ$ = ZUserIn$
    ZOldPassword$ = ZUserIn$
677 IF LEN(ZWasZ$) > 15 THEN _
       GOTO 680
    IF ZErrCode <> 0 THEN _
       GOTO 670
    CALL AllCaps (ZWasZ$)
    ZWasZ$ = ZWasZ$ + SPACE$(15 - LEN(ZWasZ$))
    IF ZPswdSave$ = ZWasZ$ THEN _
       ZPswdFailed = 0 : _
       ZOutTxt$ = "" : _
       EXIT SUB
680 CALL QuickTPut1 ("Wrong password ")
    ZLastIndex = 0
    IF NOT ZMsgPswd THEN _
       CALL UpdtCalr (ZActiveUserName$+" PW fail: " + ZWasZ$,1)
    GOTO 670
    END SUB
'
945 ' $SUBTITLE: 'Line25 - sub to build/display RBBS-PCs line 25'
' $PAGE
'
'  NAME    -- Line25
'
'  INPUTS  --     PARAMETER                    MEANING
'                 ZSubParm           = 1  BUILD DISPLAY FOR LINE 25
'                                    = 2  UPDATE LINE 25
'                 ZLockStatus$            STATUS OF LOCKS IN A MULTI-
'                                         USER ENVIRONMENT OR TIME OF
'                                         DAY USER LOGGED ON OR THE
'                                         RE-CYCLED
'
'  OUTPUTS -- ZCursorLine                 CURRENT LINE ON SCREEN
'             ZCursorRow                  CURRENT ROW ON ZCursorLine

'
'  PURPOSE -- To build or update RBBS-PC's line 25 displayed
'             on the PC screen that is running RBBS-PC.
'
      SUB Line25 STATIC
      IF ZSubParm = 2 THEN _
         GOTO 950
'
'
' *  BUILD LINE 25 DISPLAY
'
'
949 ZLine25$ = "Node " + _
               ZNodeID$ + " " + _
               ZPageStatus$ + " " + _
               MID$("AVL ",1, -4 * ZSysopAvail) + _
               MID$("PAGE ",1, -5 * ZSysopAnnoy) + _
               MID$("LPT ",1, -4 * ZPrinter) + _
               MID$("SYS ",1, -4 * ZSysopNext) + _
               MID$("XOFF ",1,-5 * ZXOffEd) + _
               MID$("CTS ",1,-4 * ZNotCTS) + _
               MID$("NEW ",1, -4 * ZNewUserDGS) + _
               " " + ZCBaud$ + " "
'
'
' *  LINE 25 UPDATE ROUTINE
'
'
950 IF NOT ZSnoop THEN _
       EXIT SUB
    ZCursorLine = CSRLIN
    ZCursorRow = POS(0)
    ZWasHH = LEN(ZActiveUserName$) + _
         LEN(ZWasCI$) + _
         LEN(ZLine25$) + _
         LEN(STR$(ZUserSecLevel)) + _
         LEN(STR$(INT(MinsRemaining))) + 2
    LOCATE 25,1
    IF ZWasHH > 63 THEN _
       ZWasHH = 0 _
    ELSE _
       ZWasHH = 64 - ZWasHH
    ZLine25Hold$ = ZLine25$ + _
                    SPACE$(ZWasHH) + _
                    STR$(ZUserSecLevel) + _
                    " " + _
                    ZActiveUserName$ + _
                    " " + _
                    ZWasCI$ + _
                    STR$(INT(MinsRemaining)) + _
                    " "
    ZLine25Hold$ = LEFT$(ZLine25Hold$, 66) + " " + ZLockStatus$
    IF ZDosANSI THEN _
       ZLine25Hold$ = ZEscape$ + "[1;36;44m" + ZLine25Hold$ + _
                      + ZEscape$ + "[K" + ZColorReset$ + ZEmphasizeOff$
    CALL LPrnt(ZLine25Hold$,0)
    LOCATE ZCursorLine,ZCursorRow
    END SUB
'
1238 ' $SUBTITLE: 'SearchCmd    - sub to search command list'
' $PAGE
'
'  NAME    -- SearchCmd
'
'  INPUTS  -- PARAMETER             MEANING
'             StartPos         POSITION TO BEGIN SEARCH AT
'             ZAllOpts$        STRING TO SEARCH (COMMAND LIST)
'             ZWasZ$           WHAT TO LOOK FOR
'
'  OUTPUTS -- WhereFound   POSITION OF ZWasZ$ IN ZAllOpts$
'                           0 IF NOT FOUND
'
'  PURPOSE -- Searches valid command list for the requested
'             command.  If the sysop has configured RBBS-PC to
'             restrict commands to only those valid within the
'             RBBS-PC subsystem, then only those commands and
'             "GLOBAL" commands are valid.  Otherwise all commands
'             are valid from any of the RBBS-PC subsections.
'
     SUB SearchCmd (StartPos,WhereFound) STATIC
1240 IF LEN(ZWasZ$) < 1 THEN _
        WhereFound = 0 : _
        EXIT SUB
     CALL Trim (ZWasZ$)
     CALL AllCaps (ZWasZ$)
     ZWasY$ = LEFT$(ZWasZ$,1)
     WhereFound = INSTR(StartPos,ZAllOpts$,ZWasY$)
     IF WhereFound = 0 THEN _        'Not found: decide whether to hunt further
        IF StartPos < 2 OR ZRestrictValidCmds THEN _
           GOTO 1242 _                           ' fully searched or restricted
        ELSE WhereFound = INSTR(1,ZAllOpts$,ZWasY$) : _           'hunt further
             GOTO 1242
     IF WhereFound => ZBegLibrary THEN _
        IF WhereFound < LEN(ZAllOpts$) - 11 THEN _
           IF ZLibType = 0 THEN _
              WhereFound = INSTR(WhereFound+1,AllOpt$,ZWasY$) : _
              IF WhereFound = 0 THEN _
                 WhereFound = INSTR(1,ZAllOpts$,ZWasY$) : _
                 IF WhereFound >= ZBegLibrary OR WhereFound = 0 THEN _
                    WhereFound = 0 : _
                    GOTO 1242
     IF NOT ZRestrictValidCmds THEN _
        GOTO 1242            ' everything found valid
'
'
' * RESTRICT COMMANDS TO SUBSYSTEMS (EXCEPT GLOBAL AND SYSOP)
'
'
     IF WhereFound > LEN(ZAllOpts$) - 11 THEN _
        IF ZUserSecLevel < ZOptSec(WhereFound) THEN _
           WhereFound = 0 : _
           EXIT SUB _
        ELSE GOTO 1242
     IF MID$(ZOrigCommands$,WhereFound,1) = "G" THEN _
        GOTO 1242          ' ACCEPT GOODBYE/GRAPHICS
     IF (WhereFound < StartPos) OR _
        (StartPos < ZBegFile AND WhereFound => ZBegFile ) OR _
        (StartPos < ZBegUtil AND WhereFound => ZBegUtil ) OR _
        (StartPos < ZBegLibrary AND WhereFound => ZBegLibrary ) THEN _
           WhereFound = 0                 ' REJECT: NOT IN Section
1242 IF WhereFound > 0 THEN _
        LSET ZLastCommand$ = ZActiveMenu$ + MID$(ZOrigCommands$,WhereFound) : _
        EXIT SUB
     IF ZMacroActive OR LEN(ZWasZ$) <> 1 THEN _
        EXIT SUB
     CALL Macro (ZWasZ$,Found)
     IF Found THEN _
        CALL FDMACEXE : _
        ZWasZ$ = ZUserIn$(1) : _
        GOTO 1240
     END SUB
'
1320 ' $SUBTITLE: 'CheckMacro - sub to check if macro exists & process'
' $PAGE
'
'  NAME    -- CheckMacro
'
'  INPUTS  -- PARAMETER             MEANING
'             Strng$               STRING TO CHECK IF IS A MACRO
'             ZMacroDrvPath$       DRIVE/PATH WHERE MACROS ARE
'             ZMacroExtension$     EXTENSION OF MACROS
'             MACRO.OFF            FORCE NO MACRO TO BE FOUND
'
'  OUTPUTS -- MacroFound           WHETHER A MACRO WAS FOUND
'             Strng$               SUBSTITUTE FOR COMMANDS
'             ZCommPortStack$      REST OF MACRO
'                                  0 IF NOT FOUND
'
'  PURPOSE -- Macro file is checked for security (1st line).
'             2nd line is substituted for passed string
'             and parsed.  Remaining part of macro put into
'             stack to be executed.
'
     SUB CheckMacro (Strng$,MacroFound) STATIC
     MacroFound = ZFalse
     IF ZMacroExtension$ = "" OR INSTR(Strng$,".") > 0 THEN _
        EXIT SUB
     IF LEN(Strng$) < ZMacroMin THEN _
        ZMacroMin = 1 : _
        EXIT SUB
     IF LEN(Strng$) = 1 THEN _
        Temp$ = Strng$ : _
        CALL AllCaps (Temp$) : _
        IF INSTR(ZAllOpts$,Temp$) > 0 THEN _
           EXIT SUB
     CALL Macro (Strng$,MacroFound)
     END SUB
'
1325 ' $SUBTITLE: 'Macro - check if macro exists & process'
' $PAGE
'
'  NAME    -- Macro
'
'  INPUTS  -- PARAMETER             MEANING
'             Strng$              STRING TO CHECK IF IS A MACRO
'             ZMacroDrvPath$      DRIVE/PATH WHERE MACROS ARE
'             ZMacroExtension$    EXTENSION OF MACROS
'             MACRO.OFF           FORCE NO MACRO TO BE FOUND
'
'  OUTPUTS -- MacroFound          WHETHER A MACRO WAS FOUND
'             Strng$              SUBSTITUTE FOR COMMANDS
'             ZCommPortStack$     REST OF MACRO
'                                 0 IF NOT FOUND
'
'  PURPOSE -- Executes a macro if found.  Does not check if macro
'             letter uses a command.
'
     SUB Macro (Strng$,MacroFound) STATIC
     MacroFound = ZFalse
     FilName$ = Strng$
     CALL BreakFileName (FilName$,ZWasDF$,Prefix$,WasX$,ZFalse)
     IF WasX$ = "" THEN _
        FilName$ = Strng$ + ZMacroExtension$
     IF ZWasDF$ = "" THEN _
        FilName$ = ZMacroDrvPath$ + FilName$
     CALL BadFile (FilName$,ZWasA)
     IF ZWasA > 1 THEN _
        EXIT SUB
     CALL FindItX (FilName$,6)
     IF NOT ZOK THEN _
        EXIT SUB
     CALL ReadDir (6,1)
     IF ZErrCode > 0 THEN _
        EXIT SUB
     CALL CheckInt (ZOutTxt$)
     IF ZErrCode > 0 OR ZUserSecLevel < ZTestedIntValue THEN _
        EXIT SUB
     ZWasA = INSTR(ZOutTxt$,"/")
     IF ZWasA > 0 THEN _    ' Check macro constraints
        WasX$ = RIGHT$(ZOutTxt$,LEN(ZOutTxt$)-ZWasA) : _
        IF RIGHT$(WasX$,1) = "/" THEN _
           IF ZLastCommand$ <> LEFT$(WasX$,LEN(WasX$)-1) THEN _
              EXIT SUB _
           ELSE GOTO 1327 _
        ELSE IF LEFT$(ZLastCommand$,LEN(WasX$)) <> WasX$ THEN _
                EXIT SUB
1327 ZMacroActive = ZTrue
     MacroFound = ZTrue
     ZMacroEcho = ZTrue
     END SUB
'
1330 ' $SUBTITLE: 'ViewHelp    - Processes requests for help'
' $PAGE
'
'  NAME    -- ViewHelp
'
'  INPUTS  -- PARAMETER             MEANING
'            Section             ORDER OF 1ST COMMAND IN CURRENT
'                                SECTION
'            GRAPHICS.DEFAULT    WHAT GRAPHICS TYPE USER WANTS
'            HelpDefault$        HELP GET IF PRESS ENTER
'            ZHelpPath$
'            ZHelpExtension$
'            ZBegFile
'            ZBegMain
'            ZBegUtil
'            ZBegLibrary
'
'  OUTPUTS -- DISPLAYS HELP
'
'  PURPOSE -- The main help processor for RBBS.  Puts up the
'             optional menu.  Accepts help with individual commands.
'
     SUB ViewHelp (Section,HelpDefault$) STATIC
     HelpMenu$ = ZHelpPath$ + _
                  "HELP" + _
                  ZHelpExtension$
     SotMenu = ZTrue
     IF ZWasQ > 1 THEN _
        ZAnsIndex = 2 : _
        ZLastIndex = ZWasQ: _
        FastHelp = ZTrue : _
        GOTO 1332
1331 IF SotMenu THEN _
        ZFileName$ = HelpMenu$ : _
        GOSUB 1350 : _
        SotMenu = ZFalse
     ZAnsIndex = 1
     ZOutTxt$ = "Help with what Command (or Topic name)" + _
          ZPressEnterExpert$
     ZSubParm = 1
     CALL TGet
     IF ZSubParm = -1 THEN _
        EXIT SUB
     IF ZWasQ = 0 THEN _
        EXIT SUB
     ZLastIndex = ZWasQ
1332 ZWasZ$ = ZUserIn$(ZAnsIndex)
     CALL AllCaps (ZWasZ$)
     IF ZWasZ$ = "?" THEN _
        ZWasZ$ = "H"
     CALL BadFile (ZWasZ$,BadFileNameIndex)
     ON BadFileNameIndex GOTO 1333,1340,1340
1333 IF LEN(ZWasZ$) <> 1 THEN _
        GOTO 1335
     CALL SearchCmd (Section,ZFF)
     IF ZFF < 1 THEN _
        ZOK = ZFalse : _
        GOTO 1336
     IF ZFF > LEN(ZAllOpts$) - 11 THEN _
        IF ZFF > LEN(ZAllOpts$) - 7 AND NOT ZSysop THEN _
           ZOK = ZFalse : _
           GOTO 1336 _
        ELSE ZWasZ$ = MID$(ZOrigCommands$,ZFF,1) : _
             GOTO 1335 _
     ELSE WasX = - (ZFF => ZBegMain) - (ZFF => ZBegFile) - (ZFF => ZBegUtil) - (ZFF => ZBegLibrary) : _
          ZWasZ$ = MID$("MFU@",WasX,1) + _
                   MID$(ZOrigCommands$,ZFF,1)
1335 ZFileName$ = ZHelpPath$ + _
                  ZWasZ$ + _
                  ZHelpExtension$
     GOSUB 1350
1336 IF NOT ZOK THEN _
        ZOutTxt$ = "No help for " + _
             ZWasZ$ : _
        CALL QuickTPut1 (ZOutTxt$) : _
        CALL UpdtCalr (ZOutTxt$,2)
     ZAnsIndex = ZAnsIndex + 1
     IF ZAnsIndex <= ZLastIndex THEN _
        GOTO 1332
     IF FastHelp THEN _
        FastHelp = ZFalse : _
        EXIT SUB
     GOTO 1331
1340 ZOK = ZFalse
     GOTO 1336
1350 CALL Graphic (ZFileName$,ZTrue)
     CALL BufFile (ZFileName$,WasX,ZFalse)
     RETURN
     END SUB
'
1380 ' $SUBTITLE: 'SecViolation - handles all security violations'
' $PAGE
'
'  NAME    -- SecViolation
'
'  INPUTS  --     PARAMETER                    MEANING
'
'  OUTPUTS -- ZCursorLine               CURRENT LINE ON SCREEN
'             ZCursorRow                CURRENT ROW ON ZCursorLine
'
'  PURPOSE -- Inform caller of security violation, augment count of
'             violations and determine whether too many occurred.
'
     SUB SecViolation
     IF ZFileSysParm < 1 THEN _
        ZLastIndex = 0 : _
        CALL FlushKeys
     SecVioHold$ = ZSecVioHelp$
     IF INSTR(ZViolation$, "Download") > 0 OR INSTR(ZViolation$, "Mark") > 0 THEN
        SecVioHold$ = ZHelpPath$ + "DOWNVIO.HLP"
        CALL FindFile (SecVioHold$,DownFind)
        IF NOT DownFind THEN _
           SecVioHold$ = ZSecVioHelp$
     END IF
     CALL BufFile (SecVioHold$,WasX,ZFalse)
     IF NOT ZOK THEN _
        CALL QuickTPut1 ("Sorry, " + ZFirstName$ + ", action not permitted")
     CALL UpdtCalr ("SV!-" + ZViolation$,2)
     CALL Muzak (3)
     ZViolationsThisSession = ZViolationsThisSession + 1
     IF ZMaxViolations = 0 OR ZViolationsThisSession <= ZMaxViolations THEN _
        EXIT SUB
1385 IF ZUserFileIndex < 1 THEN _
        EXIT SUB
     ZOutTxt$ = "SECURITY VIOLATION!  Sysop can reinstate"
     IF ZUserSecLevel <= ZMinLogonSec THEN _
        ZOutTxt$ = ""
     ZUserSecLevel = -32767
     ZDenyAccess = ZTrue
     END SUB
'
1386 ' $SUBTITLE: 'DenyAccess - sub to permanently deny access'
' $PAGE
'
'  NAME    -- DenyAccess
'
'  INPUTS  --     PARAMETER                    MEANING
'
'  OUTPUTS -- (USER'S RECORD)
'
'  PURPOSE -- Permanently resets user's security level when access denied
'
     SUB DenyAccess
     CALL TPut
     ZLogonErrorIndex = 5
     ZSubParm = 6
     CALL FileLock
     CALL OpenUser (ZHighestUserRecord)
     FIELD 5, 128 AS ZUserRecord$
     GET 5,ZUserFileIndex
     MID$(ZUserRecord$,47,2) = MKI$(ZUserSecLevel)
     PUT 5,ZUserFileIndex
     ZSubParm = 8
     CALL FileLock
     END SUB
'
1396 ' $SUBTITLE: 'TPut -- common routine to write to comm. port'
' $PAGE
'
'  NAME    -- TPut (TERMINAL PUT)
'
'  INPUTS  --     PARAMETER                    MEANING
'                     ZOutTxt$           STRING TO WRITE TO THE
'                                        COMMUNICATIONS PORT
'                 ZSubParm = 1           SKIP A LINE BEFORE WRITING
'                                        TO THE COMMUNICATIONS PORT
'                          = 2           SKIP A LINE BEFORE WRITING
'                                        TO THE COMMUNICATIONS PORT
'                                        AND THEN SKIP TWO LINES
'                                        AFTER WRITING TO THE COMM-
'                                        UNICATIONS PORT
'                           = 3          WRITE TO THE COMMUNICATIONS
'                                        PORT AND THEN SKIP TWO LINES
'                           = 4          WRITE TO THE COMMUNICATIONS
'                                        PORT WITHOUT A CR/LF
'                           = 5          WRITE TO THE COMMUNICATIONS
'                                        PORT WITH A CR/LF
'                           = 6          RESET EVERYTHING FOR INPUT STRING
'                           = 7          RE-ENTRY AFTER HANDLING A
'                                        FUNCTION KEY
'
'  OUTPUTS --  ZSubParm        = -1      CARRIER HAS BEEN DROPPED
'              ZFunctionKey    <> 0      FUNCTION KEY PRESSED
'
'  PURPOSE --  Common output routine for RBBS-PC to the
'              communications port (terminal put)
      SUB TPut STATIC
      IF ZSubParm <> 7 THEN _
         Parm = ZSubParm
      ON ZSubParm GOTO 1398,1399,1400,1403,1405,1450,1411
'
'
' *  COMMON OUTPUT ROUTINE
'
'
1398 CALL SkipLine (1)
     GOTO 1405
1399 CALL SkipLine (1)
1400 ZCR = 1
1403 ZCR = ZCR + 1
1405 ZRet = ZFalse
     IF ZWasCM THEN _
        GOTO 1435
1410 CALL FindFKey
     IF ZSubParm < 0 THEN _
        EXIT SUB
1411 ZWasY$ = ZKeyPressed$
     ZSubParm = Parm
     IF ZLocalUser THEN _
        GOTO 1430
     CALL EofComm (Char)
     IF Char = -1 THEN _
        CALL CheckCarrier : _
        IF ZSubParm = -1 THEN _
           EXIT SUB _
        ELSE GOTO 1430
     CALL GetCom(ZWasY$)
1425 IF ZSubParm = -1 THEN _
        EXIT SUB
1430 IF ZWasY$ = "" THEN _
        GOTO 1435
     ON INSTR(ZInterrupOn$,ZWasY$) GOTO 1434,1434,1473,1475,1433
     GOSUB 1476
     GOTO 1435
1433 GOSUB 1476
     IF ASC(RIGHT$(ZCommPortStack$,2)) = 13 OR _
        ZStopInterrupts THEN _
        GOTO 1435           'stack if series of [ENTER]s or no previous stack
     GOTO 1471
1434 IF ZStopInterrupts THEN _
        GOTO 1435
     ZCommPortStack$ = ""
     IF ZFossil THEN _
        CALL FOSTXPurge(ZComPort) : _
        CALL FosRXPurge(ZComPort)
     GOTO 1471
1435 LOCATE ,,1
     CALL LPrnt (ZOutTxt$,0)
1437 IF ZUpperCase THEN _
        IF ZWasGR <> 2 THEN _
           CALL AllCaps (ZOutTxt$)
     CALL PutCom (ZOutTxt$)
1450 IF ZCR <> 1 THEN _
        CALL SkipLine (1) _
     ELSE IF ZCR > 1 THEN _
             CALL SkipLine (1)
1470 ZCR = 0
     EXIT SUB
1471 IF ZOutTxt$ <> "" THEN _            ' interrupt the display
        CALL SkipLine (1)
     ZStopInterrupts = ZFalse
     ZRet = ZTrue
     ZNo = ZTrue
     ZNonStop = ZFalse
     GOTO 1470
1473 ZXOffEd = ZTrue
     GOTO 1410
1475 ZXOffEd = ZFalse
     GOTO 1410
1476 IF ASC(ZWasY$) < 127 THEN
        ZCommPortStack$ = ZCommPortStack$ + ZWasY$
        IF ZTurboKey THEN
           ZRet = ZTrue
        END IF
     END IF
     RETURN
     END SUB
'
1478 ' $SUBTITLE: 'QuickTPut - subroutine to quickly write to terminal'
' $PAGE
'
'  NAME    -- QuickTPut
'
'  INPUTS  -- PARAMETER             MEANING
'             Strng$             STRING TO WRITE OUT
'             NumReturns         NUMBER OF CARRIAGE RETURNS
'
'  OUTPUTS -- NONE
'
'  PURPOSE -- Subroutine to quickly write to the terminal.  This is
'             different from "TPut" in the things it doesn't do:
'                A.) No function key check,
'                B.) No conversion to upper case,
'                C.) No check for carrier present
'                D.) No check for imbedded carriage return in "Strng$"
'                E.) No support for XON/XOff
'
      SUB QuickTPut (Strng$,NumReturns)
      IF ZSubParm < 0 THEN _
         EXIT SUB
      IF ZUseTPut THEN _
         ZOutTxt$ = Strng$ : _
         ZSubParm = 4 : _
         CALL TPut : _
         CALL SkipLine (NumReturns) : _
         EXIT SUB
      CALL PutCom (Strng$)
      LOCATE ,,1
      CALL LPrnt (Strng$,0)
      CALL SkipLine (NumReturns)
      END SUB
'
' ***  QuickTPut1 Subroutine  ***
'
      SUB QuickTPut1 (Strng$)
      CALL QuickTPut (Strng$,1)
      END SUB
'
1480 ' $SUBTITLE: 'LPrnt    - subroutine to write to display'
' $PAGE
'
'  NAME    -- LPrnt
'
'  INPUTS  -- PARAMETER             MEANING
'             Strng$        STRING TO WRITE OUT
'             NumReturns   NUMBER OF CARRIAGE RETURNS
'
'  OUTPUTS -- NONE
'
'  PURPOSE -- Subroutine to write to the display.
'
      SUB LPrnt (Strng$,NumReturns)
      IF NOT ZSnoop THEN _
         EXIT SUB
      CALL PScrn (Strng$)
      IF ZVoiceType <> 0 AND ZTalkAll THEN _
         CALL Talk (65,Strng$)
      IF ZUseBASICWrites THEN _
         FOR WasI = 1 TO NumReturns : _
            PRINT : _
         NEXT : _
      ELSE FOR WasI = 1 TO NumReturns : _
              LOCATE ,,1 : _
              CALL ANSI(ZCrLf$,ZWasCL,ZWasCC) : _
              LOCATE ZWasCL,ZWasCC : _
              NEXT
      END SUB
'
1482 ' $SUBTITLE: 'QuickLPrnt - subroutine to quickly write to display'
' $PAGE
'
'  NAME    -- QuickLPrnt
'
'  INPUTS  -- PARAMETER             MEANING
'             Strng$        STRING TO WRITE OUT
'             Num           NUMBER OF CARRIAGE RETURNS
'
'  OUTPUTS -- NONE
'
'  PURPOSE -- Subroutine to quickly write to the display.
'             Overwrites, and puts up count
      SUB QuickLPrnt (Strng$,Num)
      IF ZSnoop THEN _
         LOCATE ,1,1 : _
         CALL Pscrn (Strng$ + STR$(Num))
      END SUB
'
1483 ' $SUBTITLE: 'PScrn    - subroutine to print to the screen'
' $PAGE
'
'  NAME    -- PScrn
'
'  INPUTS  -- PARAMETER             MEANING
'             Strng$        STRING TO WRITE OUT
'
'  OUTPUTS -- NONE
'
'  PURPOSE -- Writes to local screen regardless of whether you have
'             carrier.  Assumes have positioned cursor where you want.
'
      SUB PScrn (Strng$)
      IF Strng$ = "" THEN _
         EXIT SUB
      IF ZUseBASICWrites THEN _
         PRINT Strng$; _
      ELSE CALL ANSI (Strng$,ZWasCL,ZWasCC) : _
           LOCATE ZWasCL,ZWasCC
      END SUB
'
1485 ' $SUBTITLE: 'SkipLine - sub to write a blank line to user'
' $PAGE
'
'  NAME    -- SkipLine
'
'  INPUTS  --   PARAMETER             MEANING
'               ZLocalUser
'               ZModemStatusReg
'               NumReturns
'               ZReturnLineFeed$
'               ZSnoop
'
'  OUTPUTS -- NONE
'
'  PURPOSE -- Skip lines on the user's terminal
'
      SUB SkipLine (NumReturns)
      FOR WasI=1 TO NumReturns
          CALL PutCom (ZReturnLineFeed$)
      NEXT
      IF NOT ZSnoop THEN _
         GOTO 1486
      IF ZUseBASICWrites THEN _
         FOR WasI = 1 TO NumReturns : _
            PRINT : _
         NEXT _
      ELSE FOR WasI = 1 TO NumReturns : _
              LOCATE ,,1 : _
              CALL ANSI(ZCrLf$,ZWasCL,ZWasCC) : _
              LOCATE ZWasCL,ZWasCC : _
           NEXT
1486  ZLinesPrinted = ZLinesPrinted + NumReturns
      ZUnitCount = ZUnitCount - ZDisplayAsUnit * NumReturns
      END SUB
'
1496 ' $SUBTITLE: 'SetCrLf -- sub to set up nulls/lf's for output'
' $PAGE
'
'  NAME    -- SetCrLf
'
'  INPUTS  --   PARAMETER            MEANING
'              ZCarriageReturn$    CARRIAGE RETURN CHARACTER
'              ZLineFeed$          LINE FEED CHARACTER
'              ZLineFeeds          LINE FEED SWITCH
'              ZNul$               NULL CHARACTER
'
'  OUTPUTS -- ZReturnLineFeed$   END-OF-LINE STRING
'
'  PURPOSE -- Set up the necessary nulls/line feeds to end
'             each output to the communications port with.
'
      SUB SetCrLf
      ZReturnLineFeed$ = _
         MID$(ZCarriageReturn$,1, - (NOT ZLocalUser)) + _
         ZNul$ + _
         MID$(ZLineFeed$,1, - (ZLineFeeds <> 0))
      END SUB
'
1498 ' $SUBTITLE: 'TGet -- ask a user a question and get reply'
' $PAGE
'
'  NAME    -- TGet
'
'  INPUTS  --    PARAMETER                   MEANING
'             ZSubParm             = 1  STANDARD ENTRY
'                                  = 2  ENTRY AFTER A FUNCTION KEY
'                                       HAS BEEN HANDLED
'                                  = 3  ENTRY AFTER STACKED COMMAND
'             ZOutTxt$                  STRING TO WRITE TO THE
'                                       COMMUNICATIONS PORT
'             ZHidden                   IF THIS IS TRUE THEN ECHO
'                                       '.' INSTEAD OF ACTUAL
'                                       CHARACTER ENTERED.
'             ZForceKeyboard            IF TRUE, STACKED INPUT
'                                       IS BYPASSED AND KEYBOARD
'                                       INPUT IS READ.
'
'  OUTPUTS -- ZSubParm             = -1 CARRIER HAS BEEN DROPPED
'             ZUserIn$                  STRING THAT WAS ENTERED
'             ZWasQ                     NUMBER OF PARAMETERES THAT
'                                       WERE ENTERED WHICH WHERE
'                                       SEPARATED BY A SEMICOLON
'             ZUserIn$()                STRING MATRIX WITH EACH
'                                       ITEM CONTAINING THE STRING
'                                       THAT WAS ENTERED BETWEEN
'                                       SEMICOLONS.
'             ZFunctionKey        <>  0 FUNCTION KEY PRESSED
'             ZYes                      Reply IS "Y" OR "YES"
'             ZNo                       Reply IS "N" OR "NO"
'             ZNonStop                  Reply IS "NS" OR "C"
'             ZKillMessage              Reply IS "K"
'             ZReply                    Reply IS "RE"
'
'  SUBROUTINE PURPOSE --  COMMON ROUTINE TO ASK A USER A QUESTION
'
     SUB TGet STATIC
     MacroIndex = ZForceKeyboard
     ON ZSubParm GOTO 1500,1538,1625
'
'
' *  COMMON INPUT ROUTINE
'
'
1500 CALL Carrier
     IF ZSubParm = -1 THEN _
        EXIT SUB
     ZLinesPrinted = 0
     ZDisplayAsUnit = ZFalse
     InStack = ZFalse
     GOSUB 1580
     ZWasA = 0
     ZWasB = 0
     ZWasC = 0
     ZWasQ = 1
     ZStoreParseAt = 1
     ZYes = ZFalse
     ZUserIn$ = ""
     SleepWarn = ZTrue
     ZNo = ZFalse
     ZNonStop = (ZPageLength < 1)
     IF ZOutTxt$ = "" THEN _
        GOTO 1525
     IsMore = (LEFT$(ZOutTxt$,4) = "More") OR (LEFT$(ZOutTxt$,6) = "Press ")
     IF ZHidden THEN _
        ZOutTxt$ = ZOutTxt$ + " (dots echo)"
     IF (NOT ZVerifying) OR HoldA$ = "" THEN _
        CALL ColorPrompt (ZOutTxt$) : _
        ZOutTxt$ = ZOutTxt$ + _
             MID$("? !  ",2*ZTurboKey+1,2) : _
        HoldA$ = ZOutTxt$ _
     ELSE ZOutTxt$ = HoldA$
     ZSubParm = 4
     StopSave = ZStopInterrupts
     ZStopInterrupts = ZTrue
     CALL TPut
     ZStopInterrupts = StopSave
     IF ZSubParm = -1 OR ZFunctionKey <> 0 THEN _
        EXIT SUB
1523 IF ZPromptBell THEN _
        IF ZLocalUser THEN _
           BEEP _
        ELSE CALL PutCom(ZBellRinger$)
1525 CALL Carrier
     IF ZSubParm = -1 THEN _
        EXIT SUB
     IF LEN(ZCommPortStack$) > 0 THEN _
        InStack = ZTrue : _
        WasX = INSTR(ZCommPortStack$,ZCarriageReturn$) : _
        IF WasX > 0 THEN _
           ZOutTxt$ = LEFT$(ZCommPortStack$,WasX-1) : _
           ZCommPortStack$ = RIGHT$(ZCommPortStack$,LEN(ZCommPortStack$)-WasX) : _
           GOTO 1534 _
        ELSE ZWasY$ = LEFT$(ZCommPortStack$,1) : _
             ZCommPortStack$ = RIGHT$(ZCommPortStack$,LEN(ZCommPortStack$)-1) : _
             GOTO 1541
     IF (ZForceKeyboard OR (NOT ZMacroActive) OR (ZMacroSave > 0)) THEN _
        GOTO 1536
'
' *** MACRO PROCESSING
'
1526 CALL ReadMacro
     IF ZMacroSave > 0 THEN _
        GOTO 1500
     IF NOT ZMacroActive THEN _
        ZWasQ = 0 : _
        ZLastIndex = 0 : _
        EXIT SUB
     IF (ZDistantTGet > 0 ) OR (ZMacroTemplate$ <> "") THEN _
        GOTO 1536
1534 ZUserIn$ = ZOutTxt$   ' Not Macro command - pass to normal processing
' * strip off leading slash when not in turbokey mode so macros can be
' * written to work in both turbo and non-turbo-key mode
     IF LEFT$(ZUserIn$,1) = "/" THEN IF NOT ZTurboKeyUser THEN _
        ZUserIn$ = RIGHT$(ZUserIn$,LEN(ZUserIn$)-1) : _
        ZTurboKey = ZFalse
     IF ZMacroEcho THEN _
        ZSubParm = 4 : _
        CALL TPut
     WasX$ = ZCarriageReturn$
     GOTO 1547
1536 IF ZLocalUser THEN _
        GOTO 1537
     CALL EofComm (Char)
     IF Char <> -1 THEN _
        CALL GetCom(ZWasY$) : _
        IF ZSubParm = -1 THEN _
           EXIT SUB _
        ELSE GOTO 1541
1537 CALL CheckTime(ZAutoLogoff!, TempElapsed!, 3)
     IF TempElapsed! < ZAutoLogoffSecTime! THEN
        IF TempElapsed! <= 0 OR ZXferInfo$ = "ALO" THEN
           CALL SkipLine (1)
           ZSubParm = -1
           ZNo = ZTrue
           ZRet = ZTrue
           ZSleepDisconnect = NOT ZAutoLogoffReq
           IF ZXferInfo$ <> "ALO" THEN
              IF ZAutoLogoffReq THEN
                 CALL UpdtCalr ("Auto-logoff",1)
              ELSE
                 CALL UpdtCalr ("Sleep disconnect",1)
              END IF
              ZXferInfo$ = "ALO"
           END IF
           EXIT SUB
        ELSE
           IF SleepWarn THEN
              SleepWarn = ZFalse
              Temp! = TempElapsed!
              ZOutTxt$ = "Auto-Logoff in " + _
                          LTRIM$(STR$(ZAutoLogoffSecTime!)) + " seconds..."
              CALL RingCaller
              CALL QuickTput ("Press Enter to cancel  " + STR$(ZAutoLogoffSecTime!),0)
           ELSE
              IF Temp! - TempElapsed! > 1.0 THEN
                 CALL QuickTPut (ZBackSpace$+ZBackSpace$,0)
                 CALL QuickTPut (RIGHT$(STR$(CINT(TempElapsed!)),2),0)
                 Temp! = TempElapsed!
              END IF
           END IF
        END IF
     END IF
     CALL FindFKey
     IF ZSubParm < 0 THEN _
        EXIT SUB
1538 ZWasY$ = ZKeyPressed$
     IF ZWasY$ <> "" THEN _
        GOTO 1545
     SendRemote = ZTrue
     CALL GoIdle
     GOTO 1525
1541 SendRemote = ZRemoteEcho
     IF ZTestParity THEN _
        GOTO 1542
     IF ZWasY$ = CHR$(127) THEN _
        GOTO 1635
     GOTO 1545
1542 IF ZWasY$ = "" THEN _
        ZWasY$ = " "
     IF ASC(ZWasY$) = 141 THEN _
        OUT ZLineCntlReg,&H1A : _
        ZEightBit = ZFalse : _
        ZTestParity = ZFalse : _
        ZWasGR = ZFalse
     ZWasY$ = CHR$(ASC(ZWasY$) AND 127)
1545 WasX$ = ZWasY$
     IF ZFossil AND NOT IsMore AND ZTurboKey THEN
        CALL FosTxPurge(ZComPort)
        CALL PutCom(ZEmphasizeOff$ + ZEmphasizeOff$)
     END IF
     ZAutoLogoffReq = ZFalse
     ZXferInfo$ = ""
     IF INSTR(ZLineEditChk$,ZWasY$) > 5 _
        GOTO 1635
     IF ZWasY$ < " " AND ZWasY$ <> ZCarriageReturn$ THEN _
        GOTO 1525
     IF ZWasY$ = "^" THEN _
        GOTO 1525
     IF ZWasY$ = ZCarriageReturn$ THEN _
        GOTO 1547 _
     ELSE GOSUB 1550
     IF ZTurboKey < 1 THEN _
        GOTO 1546
     IF ZWasY$ = " " THEN _
        ZWasY$ = ""
     IF ZWasY$ <> "/" THEN _
        ZUserIn$ = ZWasY$ : _
        ZWasY$ = ZCarriageReturn$ : _
        WasX$ = ZWasY$ : _
        GOTO 1547
     ZTurboKey = 0
     GOTO 1525
1546 IF LEN(ZUserIn$) => 512 THEN _
        ZOutTxt$ = "Input too long!" : _
        ZSubParm = 5 : _
        CALL TPut : _
        ZWasY$ = ZCarriageReturn$ : _
        WasX$ = ZWasY$ : _
        GOTO 1547
     ZUserIn$ = ZUserIn$ + _
          ZWasY$
     GOTO 1525
1547 ZTurboKey = ZFalse          ' Carriage Return Handler
     ZHidden = ZFalse
     IF ZNoAdvance THEN _
        ZNoAdvance = ZFalse : _
        GOTO 1575 _
     ELSE CALL LPrnt (ZCrLf$,0) : _
          GOSUB 1551 : _
          GOTO 1570
1549 IF INSTR(ZUserIn$,";") > 0 THEN _
        CALL ExcludeCount (";",ZUserIn$,Temp) _
     ELSE IF INSTR(ZUserIn$," ") > 0 THEN _
        CALL ExcludeCount (" ",ZUserIn$,Temp) _
     ELSE Temp = 0
     RETURN
1550 IF ZLogonActive THEN _
        GOSUB 1549 : _
        ZHidden = (Temp = 2 - (ZLenIndiv > 0 AND ZStartIndiv > 0))
     IF ZHidden THEN _
        IF (WasX$ <> " " AND WasX$ <> ";") THEN _
           WasX$ = "."
     CALL LPrnt(WasX$,0)
1551 IF NOT SendRemote THEN _
        RETURN
     IF ZHidden AND (WasX$ <> " ") THEN _
        WasX$ = "."
1553 CALL PutCom (WasX$)
     RETURN
1570 IF SendRemote THEN _
        IF ZLineFeeds THEN _
           CALL PutCom (ZLineFeed$)
1575 IF LEN(ZUserIn$) > 4000 THEN _
        ZOutTxt$ = "Try again, " + _
             ZFirstName$ : _
        ZSubParm = 5 : _
        CALL TPut : _
        IF ZSubParm = -1 OR ZFunctionKey <> 0 THEN _
           EXIT SUB _
        ELSE GOTO 1500
     IF ZParseOff THEN _
        ZParseOff = ZFalse : _
        GOTO 1620
     CALL ParseIt
     IF ZWasQ = 1 THEN _
        GOTO 1622
     GOTO 1625
1580 ZAutoLogoff! = TIMER + ZWaitBeforeDisconnect
     IF ZAutoLogoffReq OR ZWaitExpired THEN _
        ZWaitExpired = ZFalse : _
        IF NOT ZSuspendAutologoff THEN _
           ZAutoLogoff! = TIMER + ZAutoLogoffSecTime!
     RETURN
1620 ZUserIn$(ZStoreParseAt) = ZUserIn$
     ZWasQ = 1
1622 IF ZUserIn$ = "" THEN _
        ZWasQ = 0 : _
        ZHidden = ZFalse : _
        GOTO 1628
1625 IF LEN(ZUserIn$) < 4 THEN _
        WasX$ = LEFT$(ZUserIn$,3): _
        CALL AllCaps (WasX$) : _
        ZYes = (INSTR("YES",WasX$) = 1) : _
        ZNo = (INSTR("NO",WasX$) = 1 OR WasX$ = "A" OR WasX$ = "Q") : _
        ZReply = (WasX$ = "RE") OR ZReply : _
        ZKillMessage = (WasX$ = "K") OR ZKillMessage
     ZHidden = ZFalse
1628 CALL VerifyAns
     IF NOT ZOK THEN _
        CALL QuickTPut1 ("Invalid answer <" + ZUserIn$(1) + ">") : _
        GOTO 1500
     HoldA$ = ""
     ZForceKeyboard = ZFalse
     IF ZMacroSave > 0 THEN _
        ZGSRAra$(ZMacroSave) = ZUserIn$ : _
        ZMacroSave = 0 : _
        GOTO 1632
     IF (ZDistantTGet > 0) OR (ZMacroTemplate$ <> "") THEN _
        CALL WipeLine (38) : _
        IF NOT ZNo THEN _
           GOTO 1632 _
        ELSE ZWasQ = 0 : _
             ZMacroTemplate$ = "" : _
             ZDistantTGet = 0 : _
             ZNo = ZFalse : _
             GOTO 1633
     IF ZMacroActive THEN _
        ZLastIndex = ZWasQ : _
        FirstIndex = 1: _
        ZMacroActive = NOT EOF(6) : _
        EXIT SUB
     IF ZAnsIndex > 255 OR ((NOT InStack) AND INSTR(ZUserIn$,".") > 0) THEN _
        EXIT SUB
     IF MacroIndex OR ZSubParm < 3 THEN _
        MacroIndex = 1 _
     ELSE MacroIndex = ZAnsIndex
     CALL NoPath (ZUserIn$(MacroIndex),Found)
     IF Found THEN _
        EXIT SUB
     CALL CheckMacro (ZUserIn$(MacroIndex),Found)
     IF Found THEN _
        ZStoreParseAt = ZAnsIndex : _
        GOTO 1525
     EXIT SUB
1632 ZUserIn$ = ""
     ZForceKeyboard = ZFalse
1633 GOSUB 1580
     ZWasQ = 1
     GOTO 1525
1635 IF LEN(ZUserIn$) = 0 THEN _
        GOTO 1525
     ZUserIn$ = LEFT$(ZUserIn$,LEN(ZUserIn$)-1)
     CALL LPrnt(ZLocalBksp$,0)
     IF SendRemote THEN _
        CALL PutCom(ZBackSpace$)
     GOTO 1525
     END SUB
'
1636 ' $SUBTITLE: 'RingCaller - sub to use sound + screen emphasis'
' $PAGE
'
'  NAME    -- RingCaller
'
'  INPUTS  --     PARAMETER                    MEANING
'                 ZOutTxt$                STRING TO EMPHASIZE
'
'  OUTPUTS --  none
'
'  PURPOSE --  Rings the users bell before and after string
'              (but not snooping sysop) and adds emphasis around
'              message sent.
'
     SUB RingCaller
     WasX$ = LEFT$(ZBellRinger$,-ZLocalUser)
     CALL PutCom (ZBellRinger$)
     CALL LPrnt (WasX$,0)
     ZSubParm = 2
     ZOutTxt$ = ZEmphasizeOn$ + ZOutTxt$ + ZEmphasizeOff$
     CALL TPut
     CALL PutCom (ZBellRinger$)
     CALL LPrnt (WasX$,0)
     END SUB
'
1637 ' $SUBTITLE: 'ParseIt - subroutine to parse a string'
' $PAGE
'
'  NAME    -- ParseIt
'
'  INPUTS  --     PARAMETER              MEANING
'                 ZUserIn$             STRING TO PARSE
'                 ZSemiOnly            ONLY PARSE USING SEMI-COLON
'
'  OUTPUTS --  ZWasQ                   NUMBER PARSED
'              ZUserIn$()              PARSED STRINGS
'
'  PURPOSE --  To parse a string into pieces.  Uses semicolon
'              if exists, otherwise space, otherwise comma
'
     SUB ParseIt STATIC
     ZWasA = INSTR(ZUserIn$,";")
     IF ZWasA > 0 THEN _
        ParseChar$ = ";" _
     ELSE IF ZSemiOnly THEN _
             ZSemiOnly = ZFalse : _
             GOTO 1638 _
          ELSE IF ZUserIn$ <> SPACE$(LEN(ZUserIn$)) THEN _
             CALL Trim (ZUserIn$) : _
             WasX$ = ZUserIn$ : _
             ZWasA = INSTR(ZUserIn$,"  ") : _
             WHILE ZWasA > 0 : _
                ZUserIn$ = LEFT$(ZUserIn$,ZWasA - 1) + _
                     MID$(ZUserIn$,ZWasA + 1) : _
                ZWasA = INSTR(ZWasA,ZUserIn$,"  ") : _
             WEND : _
             ZWasA = INSTR(ZUserIn$," ") : _
             IF ZWasA > 1 THEN _
                ParseChar$ = " " _
             ELSE ZWasA = INSTR(ZUserIn$,",") : _
                  ParseChar$ = ","
     IF ZWasA > 1 THEN _
        GOTO 1639
1638 ZWasDF$ = ZUserIn$
     CALL AllCaps (ZWasDF$)
     IF ZWasDF$ = "NS" THEN _
         ZUserIn$ = "C" : _
         ZNonStop = ZTrue
     ZUserIn$(ZStoreParseAt) = ZUserIn$
     ZNonStop = ZNonStop OR (ZWasDF$ = "C" AND NOT ZStackC)
     GOTO 1642
1639 ZUserIn$(ZStoreParseAt) = LEFT$(ZUserIn$,ZWasA - 1)
     ZWasA = ZWasA + 1
     ZEOL = ZFalse
1640 ZWasB = INSTR(ZWasA,ZUserIn$,ParseChar$)
     ZWasC = ZWasB-ZWasA
     IF ZWasC < 1 THEN _
        ZEOL = ZTrue : _
        ZWasC = 128
     ZWasDF$ = MID$(ZUserIn$,ZWasA,ZWasC)
     IF ZWasDF$ = "" THEN GOTO 1641
        ZWasQ = ZWasQ + 1
        ZStoreParseAt = ZStoreParseAt + 1
        ZUserIn$(ZStoreParseAt) = ZWasDF$
        CALL AllCaps(ZWasDF$)
        WasX = INSTR(";NS;/G;C;",";"+ZWasDF$+";")
        IF WasX = 0 THEN GOTO 1641
           ZNonStop = ZNonStop OR (WasX = 1) OR (WasX = 7 AND NOT ZStackC)
     IF ZStoreParseAt > 1 THEN IF INSTR("Jj",ZUserIn$(ZStoreParseAt-1)) THEN _
        ZNonStop = (ZPageLength < 1)
     ZAutoLogoffReq = ZAutoLogoffReq OR (WasX = 4)
     IF ZAutoLogoffReq THEN
        IF ZFileSysParm > 0 AND (ZFF = 2 OR ZFF = 7) THEN _
           CALL SkipLine (1)
        CALL QuickTPut1 (ZEmphasizeOn$ + "Auto-logoff" + _
                          " requested" + ZEmphasizeOff$)
     END IF
     IF ZWasQ > 0 AND WasX < 7 THEN _
        ZWasQ = ZWasQ - 1 : _
        ZStoreParseAt = ZStoreParseAt - 1
1641 IF NOT ZEOL AND ZWasQ < 50 THEN _
        ZWasA = ZWasB + 1 : _
        GOTO 1640
     IF ParseChar$ <> ";" THEN _
        ZUserIn$ = WasX$
1642 ZStackC = ZFalse
     END SUB
'
1650 ' $SUBTITLE: 'PopCmdStack - prompt for value with command stack check'
'
     SUB PopCmdStack STATIC
     CALL CheckCarrier
     IF ZSubParm = -1 THEN _
        ZLastIndex = 0 : _
        ZWasQ = 0 : _
        EXIT SUB
     ZWasQ = 1
1651 IF ZAnsIndex < ZLastIndex THEN _
        ZAnsIndex = ZAnsIndex + 1 : _
        ZUserIn$ = ZUserIn$(ZAnsIndex) : _
        IF MID$(ZLastCommand$,2,1) <> " " AND (NOT ZStackC) AND _
                ZAnsIndex > 1 AND INSTR("Cc",ZUserIn$) > 0 AND _
                LEN(ZUserIn$) = 1 THEN _
           GOTO 1651 _
        ELSE ZSubParm = 3 : _
             ZTurboKey = 0 : _
             CALL TGet : _
             GOTO 1652
     ZLastIndex = 0
     ZAnsIndex = 1
     ZSubParm = 1
     ZSearchingAll = ZFalse
     CALL TGet
     ZLastIndex = ZWasQ
1652 IF ZStoreParseAt > ZLastIndex THEN _
        IF ZLastIndex > 0 THEN _
           ZLastIndex = ZStoreParseAt
     ZStackC = ZFalse
     ZParseOff = ZFalse
     END SUB
'
1654 ' $SUBTITLE: 'SetBaud - sub to set the baud rate in the RS232'
' $PAGE
'
'  NAME    -- SetBaud
'
'  INPUTS  --     PARAMETER                    MEANING
'             ZBaudRateDivisor   NUMBER TO DIVIDE THE 8250 CHIP'S
'                                 PROGRAMABLE CLOCK TO ADJUST THE
'                                 BAUD RATE TO THE USER'S BAUD
'                                 RATE (INDEPENDENT OF THE BAUD
'                                 RATE USED TO OPEN THE COMM. PORT)
'
'        DESIRED BAUD        DIVISIOR (DECIMAL) TO OBTAIN DESIRED BAUD RATE
'            RATE              PCjr         PC AND XT
'              50             2237             2304
'              75             1491             1536
'             110             1017             1047
'             134.5            832              857
'             150              746              768
'             300              373              384
'             600              186              192
'            1200               93               96
'            1800               62               64
'            2000               56               58
'            2400               47               48
'            3600               31               32
'            4800               23               24
'            7200          not available         16
'            9600          not available         12
'           12000          not available         10
'           14400          not available          8
'           19200          not available          6
'           21600               "                 5
'           24000               "                 4
'           26400               "                 4
'           28800               "                 4
'           38400               "                 3
'           57600               "                 2
'  OUTPUTS -- BAUD RATE SET IN THE RS232 INTERFACE
'
'  PURPOSE -- To set the baud rate in the RS232 interface
'             inpependent of the baud rate the communications port
'             was opened at
'
     SUB SetBaud
     IF ZCBaud$ = "" THEN _
        IF VAL(ZNetBaud$) > 0 THEN _
           ZCBaud$ = STR$(ZBaudTest!) : _
           CALL Trim (ZCBaud$) _
        ELSE _
           ZCBaud$ = MID$(ZBaudRates$,(-5 * ZBPS),5) : _
           CALL Trim (ZCBaud$)
     Temp! = VAL(ZCBaud$)
     IF Temp! > 0 THEN CALL SetBPS (Temp!,ZCBPS)
     IF (ZCBPS = 0 OR Temp! = 0) THEN ZCBPS = ZBPS
     IF NOT ZKeepInitBaud THEN _
        ZTalkToModemAt$ =  MID$(ZBaudRates$,(-5 * ZBPS),5) _
     ELSE ZTalkToModemAt$ = ZModemInitBaud$
     CALL Trim (ZTalkToModemAt$)
     IF LEN(ZTalkToModemAt$) < 5 THEN _
        ZTalkToModemAt$ = SPACE$(4 - LEN(ZTalkToModemAt$)) + _
                            ZTalkToModemAt$
     IF ZEightBit THEN _
        Parity = 2 : _                                    ' No PARITY
        DataBits = 3 : _                                  ' 8 DATA BITS
        StopBits = 0 _                                    ' 1 STOP BIT
     ELSE Parity = 3 : _                                  ' EVEN PARITY
          DataBits = 2 : _                                ' 7 DATA BITS
          StopBits = 0                                    ' 1 STOP BIT
     ComSpeed! = VAL(ZTalkToModemAt$)
     SELECT CASE ComSpeed!
        CASE 300
           ZBaudRateDivisor = &H180 + (11 * (ZComputerType = 2))
           WasI = ComSpeed!
        CASE 450
           ZBaudRateDivisor = &H100 + (8 * (ZComputerType = 2))
           WasI = ComSpeed!
        CASE 1200
           ZBaudRateDivisor = &H60 + (3 * (ZComputerType = 2))
           WasI = ComSpeed!
        CASE 2400
           ZBaudRateDivisor = &H30 + (1 * (ZComputerType = 2))
           WasI = ComSpeed!
        CASE 4800
           ZBaudRateDivisor = &H18
           WasI = ComSpeed!
        CASE 7200
           ZBaudRateDivisor = &H10
           WasI = ComSpeed!
        CASE 9600
           ZBaudRateDivisor = &HC
           WasI = ComSpeed!
        CASE 12000
           ZBaudRateDivisor = &HA
           WasI = &H2E00
        CASE 14400
           ZBaudRateDivisor = &H8
           WasI = &H3840
        CASE 16800
           ZBaudRateDivisor = &H7
           WasI = &H41A0
        CASE 19200
           ZBaudRateDivisor = &H6
           WasI = &H4B00
        CASE 21600
           ZBaudRateDivisor = &H5
           WasI = &H5460
        CASE 24000
           ZBaudRateDivisor = &H4
           WasI = &H5E88
        CASE 26400
           ZBaudRateDivisor = &H4
           WasI = &H6720
        CASE 28800
           ZBaudRateDivisor = &H4
           WasI = &H7080
        CASE 38400
           ZBaudRateDivisor = &H3
           WasI = &H9600
        CASE 57600
           ZBaudRateDivisor = &H2
           WasI = &HE100
     END SELECT
     IF ZFossil THEN _
        CALL FosSpeed(ZComPort,WasI,Parity,DataBits,StopBits) : _
        EXIT SUB
     MostSignifByte = FIX (ZBaudRateDivisor / 256)
     LeastSignifByte = ZBaudRateDivisor - (MostSignifByte * 256)
     LineCntlStatus = INP(ZLineCntlReg)
     MSBSave = INP(ZMSB)
     OUT ZMSB,0
     OUT ZLineCntlReg,LineCntlStatus OR 128
     OUT ZLSB,LeastSignifByte
     OUT ZMSB,MostSignifByte
     OUT ZLineCntlReg,LineCntlStatus
     OUT ZMSB,MSBSave
     END SUB
'
2018 ' $SUBTITLE: 'SetWhoTo - subroutine to get who a msg/upload is to'
' $PAGE
'
'  NAME    -- SetWhoTo
'
'  INPUTS  --     PARAMETER                    MEANING
'                 HighestUserRecord
'
'  OUTPUTS --     MsgTo$                       WHO MESSAGE IS TO
'                 RcvrRecNum                   USER RECORD # OF WHO TO
'
'  PURPOSE --  Asks who a message/upload is to and checks if receiver exists
'              Will also check to see if message base being used is an
'              I.DEF message base.  If true, will call IConference routine
'              for message addressing
'
'
     SUB SetWhoTo (EnableCC,MsgTo$,MsgFrom$,RcvrRecNum,Found,AllowPub,_
                   FirstLineText$,SecondLineText$,AddressLine) STATIC
     MsgToHold$ = ""
     MsgFwd = (UCASE$(ZUserIn$(1)) = "F")
     EnterMsg = (UCASE$(ZUserIn$(1)) = "E")
     Temp$ = MsgFrom$
     TempTo$ = MsgTo$
     CALL Trim (Temp$)
     CALL Trim (TempTo$)
     ZNumHeaders = 0
     CALL KillWork (ZNodeWorkFile$)
     IF ZIConference AND ZConfMode THEN _
        CALL IConference(ZMainMsgFile$,MsgTo$,FirstLineText$,SecondLineText$,AddressLine)
2020 IF MsgTo$ <> "" AND MsgTo$ <> "UUCP" THEN _
        GOTO 2032
2021 IF MsgTo$ = "UUCP" THEN
        IF FirstLineText$ = "" THEN _
           GOTO 2032
        MsgToHold$ = MsgTo$
        ZOutTxt$ = "Enter Users Address" + ZPressEnterExpert$
     ELSE
        ZOutTxt$ = "To " + LEFT$("A)ll,",-5*AllowPub) + _
                   LEFT$("(S)ysop,",-8*(ZNetConference = ZFalse)) + _
                   LEFT$("D)istribution,",-14*EnableCC) + _
                   " or name (2 Char. Min.)" + ZPressEnterExpert$
     END IF
     CALL SkipLine (1)
     ZSemiOnly = ZTrue
     CALL PopCmdStack
     IF ZWasQ = 0 OR ZSubParm < 0 THEN
        IF MsgToHold$ = "UUCP" THEN _
           MsgToHold$ = "" : _
           FirstLineText$ = "" : _
           SecondLineText$ = ""
        GOTO 2034
     END IF
     IF LEN(ZUserIn$(ZAnsIndex)) > 30 AND MsgToHold$ <> "UUCP" THEN
        CALL QuickTPut1 (ZFG4$ + "30 Char. Max" + ZEmphasizeOff$)
        GOTO 2021
     END IF
     IF INSTR(ZUserIn$(ZAnsIndex),"@") = 0 AND ZIConference THEN
        CALL QuickTPut1 (ZFGC$ + " ** Invalid Address **" + ZEmphasizeOff$)
        GOTO 2021
     END IF
     Found = ZTrue
     CALL Trim (ZUserIn$(ZAnsIndex))
     ZWasDF$ = ZUserIn$(ZAnsIndex)
     CALL Remove (ZWasDF$,",")
     IF NOT ZIConference THEN _
        CALL AllCaps (ZWasDF$)
     ZUserIn$(ZAnsIndex) = ZWasDF$
     IF ZWasDF$ = "A" AND AllowPub THEN
        MsgTo$ = "ALL"
     ELSE
        IF ZWasDF$ = "S" THEN
           MsgTo$ = "SYSOP"
        ELSE
           IF ZWasDF$ = "D" AND EnableCC THEN
              GOTO 2025
           ELSE
              MsgTo$ = ZUserIn$(ZAnsIndex)
              IF NOT ZIConference THEN _
                 CALL AllCaps (MsgTo$)
           END IF
        END IF
     END IF
     GOTO 2032
2022 IF NOT ZExpertUser THEN _
        GOTO 2025
2024 ZFileName$ = ZHelpPath$ + ZDistriHelp$ + ZHelpExtension$
     CALL BufFile (ZFileName$,WasX,ZFalse)
2025 ZOutTxt$ = "Use what distribution list (H)elp)"
     CALL PopCmdStack
     IF ZWasQ = 0 THEN _
        GOTO 2021
     ZFileName$ = ZUserIn$(ZAnsIndex)
     CALL AllCaps (ZFileName$)
     IF INSTR("?H",ZFileName$) > 0 THEN _
        GOTO 2024
     CALL BadFile (ZFileName$,BadFileNameIndex)
     ON BadFileNameIndex GOTO 2026,2025,2025
2026 ZFileName$ = ZDistriPath$ + ZFileName$ + ".LST"
     CALL FindItX (ZFileName$,7)
     IF NOT ZOK THEN _
        CALL QuickTPUT1 (ZFGB$ + ZUserIn$ + ZFGF$ + " not found!" + ZEmphasizeOff$) : _
        GOTO 2024
     ZNumHeaders = 0
     CALL OpenWork (2,ZNodeWorkFile$,ZTrue)
     WHILE NOT EOF(7)
        CALL ReadDir (7,1)
        CALL AllCaps (ZOutTxt$)
        ZWasDF$ = ZOutTxt$
        CALL WhoCheck (ZOutTxt$, Found, RcvrRecNum)
        ZNumHeaders = ZNumHeaders + 1
        CALL PrintWork (2,ZWasDF$ + "," + STR$(-RcvrRecNum*Found),ZFalse)
     WEND
     CLOSE 7
     CLOSE 2
     GOTO 2034
2032 RcvrRecNum = 0
     IF MsgTo$ = "UUCP" OR MsgToHold$ = "UUCP" AND (ZNetConference or ZIConference) THEN _
        GOTO 2033
     IF MsgTo$ <> "ALL" THEN
        IF (LEFT$(MsgTo$,4) <> "ALL " AND ZStartHash = 1) THEN
           CALL CheckInt (MsgTo$)
           IF ZTestedIntValue = 0 OR NOT ZSysOp OR (ZSysOp AND ZFileSysParm < 1) THEN
           ZWasDF = INSTR(MsgTo$+" @"," @")
           TempHashValue$ = LEFT$(MsgTo$,ZWasDF-1)
           AliasConf = ZFalse
           CALL WhoCheck (TempHashValue$,Found,RcvrRecNum)
           IF NOT Found THEN _
              CALL AliasChk (MsgTo$,Found,TempMsgTo$,AliasConf) : _
              IF Found THEN _
                 ZStartHash = 1 : _
                 CALL WhoCheck (TempMsgTo$,Found,RcvrRecNum)
           IF Found AND MsgTo$ = ZSecretName$ THEN _
              CALL QuickTPut1 (ZFGF$ + MsgTo$ + ZFGC$ + " not active user." + _
                              ZEmphasizeOff$) : _
              Found = ZFalse
           IF (NOT Found) AND (NOT ZNetConference) AND (NOT AliasConf) _
                  AND (NOT ZNoPeek) THEN
              ZOutTxt$ = "Send to: "
              CALL QuickPeek (MsgTo$,Found)
              IF Found THEN _
                 ZStartHash = 1 : _
                 CALL WhoCheck (MsgTo$,Found,RcvrRecNum)
           END IF
           IF NOT Found THEN
              ZLastIndex = 0
              RcvrRecNum = 0
              IF NOT ZReply THEN
                 CALL WipeLine(79)
                 CALL QuickTPut (ZFGC$ + "No match found for: " + _
                                 ZFGF$ + MsgTo$ + ZEmphasizeOff$,1)
                 ZOutTxt$ = ZFG4$ + "Send anyway (Y,[N]" + ZFG4$ + ")" + ZEmphasizeOff$
                 ZTurboKey = -ZTurboKeyUser
                 ZLastIndex = 0
                 GOSUB 2035
                 IF NOT ZYes THEN _
                    GOTO 2021
              END IF
           END IF
           END IF
        END IF
     END IF
2033 IF MsgTo$ = Temp$ THEN _
        ZFunnyMessage = ZTrue : _
        ZOutTxt$ = "Really send this to YOURSELF (Y,[N])" : _
        ZLastIndex = 0 : _
        GOSUB 2035 : _
        IF NOT ZYes THEN _
           ZFunnyMessage = ZFalse : _
           MsgTo$ = ""
     CALL OpenWork (2,ZNodeWorkFile$,ZTrue)
     IF MsgToHold$ <> "" THEN _
        CALL PrintWork (2,MsgToHold$ + "," + STR$(RcvrRecNum),ZFalse) _
     ELSE CALL PrintWork (2,MsgTo$ + "," + STR$(RcvrRecNum),ZFalse)
     CLOSE 2
     ZNumHeaders = ZNumHeaders + 1
     IF EnableCC AND (NOT ZReply) AND MsgTo$ <> "ALL" AND _
        MsgTo$ <> "" AND LEFT$(MsgTo$,4) <> "ALL " AND _
        (NOT ZSysopComment) AND (NOT ZSysopMsg) THEN _
             ZOutTxt$ = "Carbon copy to another (Y,[N])" : _
             CALL PopCmdStack : _
             IF ZYes THEN _
                GOTO 2021
2034 IF ZNumHeaders < 1 THEN _
        MsgTo$ = "" _
     ELSE IF ZNumHeaders > 1 THEN _
        MsgTo$ = "(list)"
     IF MsgToHold$ <> "" THEN _
        GOSUB 2036
     EXIT SUB
2035 ZSubParm = 1
     CALL TGet
     IF ZSubParm < 0 THEN _
        EXIT SUB
     RETURN
2036 IF AddressLine = 1 THEN
        FirstLineText$ = RTRIM$(FirstLineText$) + SPACE$(1) + MsgTo$
     ELSE
        IF AddressLine = 2 THEN
           SecondLineText$ = RTRIM$(SecondLineText$) + SPACE$(1) + MsgTo$
        ELSE
           FirstLineText$ = RTRIM$(FirstLineText$) + SPACE$(1) + MsgTO$
        END IF
     END IF
     MsgTo$ = MsgToHold$
     RETURN
     END SUB
'
2055 ' $SUBTITLE: 'MsgProt - gets protection wanted for a message'
' $PAGE
'
'  NAME    -- MsgProt
'
'  INPUTS  --     PARAMETER                    MEANING
'                 MsgTo$
'                 Found
'
'  OUTPUTS --  ZPswd$                     PROTECTION DESIRED
'
'  PURPOSE --  Sets protection desired for a new message
'
     SUB MsgProt (MsgTo$,Found,MsgPswd$) STATIC
2060 IF INSTR(ZMsgSecCats$,"U") = 0 THEN _
        ZOutTxt$ = "" _
     ELSE ZOutTxt$ = " (U)nrestricted," : _
          IF MsgTo$ = "ALL" THEN _
             MsgPswd$ = "" : _
             GOTO 2061
     IF INSTR(ZMsgSecCats$,"R") THEN _
        ZOutTxt$ = ZOutTxt$ + " (R)eceiver Only,"
     IF INSTR(ZMsgSecCats$,"P") THEN _
        ZOutTxt$ = ZOutTxt$ + " (P)assworded,"
2061 ZOutTxt$ = "Make msg" + ZOutTxt$ + " (E)dit more, H)elp"
     IF MsgPswd$ = "^READ^" THEN _
        DefaultProt$ = "R" : _
        GOTO 2065
     IF LEFT$(MsgPswd$,1) = "!" THEN _
        DefaultProt$ = "P" _
     ELSE _
        DefaultProt$ = "U"
2065 IF INSTR(ZMsgSecCats$,DefaultProt$) > 0 THEN _
        MID$(ZOutTxt$,INSTR(ZOutTxt$,"("+DefaultProt$+")"),3) = "["+DefaultProt$+"]"
     ZTurboKey = -ZTurboKeyUser
     GOSUB 2096
     IF ZWasQ = 0 THEN _
        ZUserIn$(ZAnsIndex) = DefaultProt$
     ZWasZ$ = LEFT$(ZUserIn$(ZAnsIndex),1)
     CALL AllCaps (ZWasZ$)
     IF INSTR(ZMsgSecCats$,ZWasZ$) = 0 THEN _
        GOTO 2060
     ON INSTR("RUPHE",ZWasZ$) GOTO 2075,2090,2075,2070,2067
     GOTO 2060
2067 MsgPswd$ = ""
     EXIT SUB
'
' **  DISPLAY MESSAGE PROTECT HELP   *
'
2070 CALL BufFile (ZHelp$(3),WasX,ZFalse)
     GOTO 2060
'
' ** MAKE MESSAGE READ PROTECTED (ONLY ADDRESSEE AND SYSOP CAN READ IT) *
'
2075 IF MsgTo$ = "ALL" THEN _
        CALL QuickTPut1 ("Msg to ALL cannot be private") : _
        GOTO 2060
     IF ZWasZ$ = "P" THEN _
        GOTO 2088
2081 CALL QuickTPut1 ("Sending private mail to " + MsgTo$)
2084 MsgPswd$ = "^READ^"
     EXIT SUB
2085 ZOutTxt$ = "Password"
     GOSUB 2096
     IF ZWasQ = 0 THEN _
        IF LEFT$(MsgPswd$,1) = "!" THEN _
           MsgPswd$ = MID$(MsgPswd$,2) : _
           CALL QuickTPut1 ("Password is " + MsgPswd$) : _
           RETURN _
        ELSE _
        GOTO 2085
     IF LEN(ZUserIn$) > WasL THEN _
        CALL QuickTPut1 (STR$(WasL) + " Chars. max") : _
        GOTO 2085
     IF WasL = 15 AND LEFT$(ZUserIn$,1) = "!" THEN _
        CALL QuickTPut1 ("Password can't begin with '!'") : _
        GOTO 2085
     RETURN
'
' **  PASSWORD PROTECT MESSAGE (USERS WITH PASSWORD AND SYSOP CAN READ) *
'
2088 ZOutTxt$ = "Receiver(s) MUST know password to read msg.  Use password (Y,[N])"
     ZTurboKey = -ZTurboKeyUser
     GOSUB 2096
     IF NOT ZYes THEN _
        GOTO 2070
     WasL = 14
     WasA1$ = "!"
     GOSUB 2085
     CALL AllCaps (ZUserIn$)
     GOTO 2092
'
' ** MAKE MESSAGE KILL PROTECTED (ONLY SENDER, ADDRESSEE AND SYSOP CAN KILL) *
'
2090 WasL = 15
     WasA1$ = ""
     ZUserIn$ = "^KILL^"
2092 MsgPswd$ = WasA1$ + ZUserIn$
     EXIT SUB
2093 ZTurboKey = -ZTurboKeyUser
2094 ZSubParm = 1
     CALL TGet
2095 IF ZSubParm = -1 THEN _
        EXIT SUB
     RETURN
2096 CALL PopCmdStack
     GOTO 2095
     END SUB
'
2250 ' $SUBTITLE: 'WhoCheck - Checks whether user exists'
' $PAGE
'
'  NAME    -- WhoCheck
'
'  INPUTS  --   PARAMETER                    MEANING
'              WhoFind$                USER TO FIND
'
'  OUTPUTS --  WhoFound                WHETHER USER FOUND
'              UserNumFound            RECORD # OF USER
'
'  PURPOSE --  Validate that user record exists.  Sysop
'              counted as found even if lack user record.
'
     SUB WhoCheck (WhoFind$,WhoFound,UserNumFound) STATIC
     UserNumFound = 0
     IF ZStartHash <> 1 THEN _
        WhoFound = ZTrue : _
        EXIT SUB
     Work128$ = ZUserRecord$
     WhoFound = ZFalse
     ToSysop = (INSTR(WhoFind$,"SYSOP") > 0 OR _
                INSTR(WhoFind$,ZSysopFirstName$ + " " + ZSysopLastName$) > 0)
     CALL OpenUser (HighestUserRecord)
     FIELD 5, 128 AS ZUserRecord$
     IF ToSysop THEN _
        WasX$ = ZSecretName$ : _
        ZMenuNewSysop = ZMenuNewSysop + 1 _
     ELSE WasX$ = WhoFind$
     ZWasDF = INSTR(WasX$+"@","@")
     WasX$ = LEFT$(WasX$,ZWasDF)
     IF LEN(WasX$) > 1 THEN _
        CALL FindUser (WasX$,"",ZStartHash,ZLenHash,_
                       0,0,HighestUserRecord,WhoFound,_
                       UserNumFound,ZWasSL)
     LSET ZUserRecord$ = Work128$
     IF NOT WhoFound THEN _
        IF ToSysop THEN _
           WhoFound = ZTrue
     END SUB
'
2618 ' $SUBTITLE: 'EditALine - Edits a line in a message'
' $PAGE
'
'  NAME    -- EditALine
'
'  INPUTS  --     PARAMETER                    MEANING
'                 WasL                        LINE # TO EDIT
'
'  OUTPUTS --  ZOutTxt$(WasL)                 EDITED LINE
'
'  PURPOSE --  Edit a line in a message.
'
     SUB EditALine (WasL) STATIC
2620 ZOutTxt$ = "Line #" + _
          STR$(WasL) + _
          " is:" + _
          ZReturnLineFeed$ + _
          ZOutTxt$(WasL)
     ZSubParm = 3
     CALL TPut
     GOSUB 2695
     IF NOT ZExpertUser THEN _
        CALL QuickTPut1 ("Search & replace")
     ZOutTxt$ = "Search for" + _
          ZPressEnterExpert$
     ZMacroMin = 99
     ZParseOff = ZTrue
     ZSubParm = 1
     GOSUB 2694
     IF ZWasQ = 0 THEN _
        EXIT SUB
     ZWasY$ = LEFT$(ZUserIn$,1)
     IF ZWasY$ = RIGHT$(ZUserIn$,1) THEN _
        IF LEN(ZUserIn$) > 2 THEN _
           WasX = INSTR(2,ZUserIn$,ZWasY$) : _
           IF WasX < LEN(ZUserIn$) THEN _
              IF ZWasY$ < "0" OR (ZWasY$ > "9" AND ZWasY$ < "A") THEN _
                 ZUserIn$ = MID$(ZUserIn$,2,LEN(ZUserIn$)-2) : _
                 WasX = WasX - 1 : _
                 GOTO 2622
     WasX = INSTR(ZUserIn$,";")
2622 IF WasX > 0 THEN _
        WasX$ = LEFT$(ZUserIn$,WasX-1) : _
        ZWasY$ = RIGHT$(ZUserIn$,LEN(ZUserIn$)-WasX) : _
        GOTO 2660
     WasX$ = ZUserIn$
     ZOutTxt$ = "And replace by"
     ZParseOff = ZTrue
     ZSubParm = 1
     ZMacroMin = 99
     GOSUB 2694
     ZWasY$ = ZUserIn$
2660 WasX = INSTR(1,ZOutTxt$(WasL),WasX$)
     IF WasX = 0 THEN _
        CALL QuickTPut1 ("<" + WasX$ + "> not found in line" + STR$(WasL)) : _
        GOTO 2620
2670 ZFF = LEN(WasX$)
     WasJJ = LEN(ZWasY$)
     IF ZFF = WasJJ THEN _
        MID$(ZOutTxt$(WasL),WasX) = ZWasY$ : _
        GOTO 2620
2690 ZWasDF$ = LEFT$(ZOutTxt$(WasL),WasX - 1)
     ZOutTxt$(WasL) = ZWasDF$ + _
             ZWasY$ + _
             MID$(ZOutTxt$(WasL),WasX + ZFF)
     IF LEN(ZOutTxt$(WasL)) > ZRightMargin THEN _
        CALL WordWrap (ZRightMargin, ZLinesInMsg, ZOutTxt$())
     GOTO 2620
2694 CALL TGet
2695 IF ZSubParm > -1 THEN _
        RETURN
     END SUB
'
3700 ' $SUBTITLE: 'LineEdit  - subroutine to produce edited line'
' $PAGE
'
'  NAME    -- LineEdit
'
'  INPUTS  -- PARAMETER             MEANING
'             ZBackArrow$
'             ZBackSpace$
'             ZCarriageReturn$
'             ZLineFeed$
'             ZLineMes$          BUFFER SPACE TO USE FOR HOLDING LINE
'             ZLocalUser
'             MaxLen             MAXIMUM LENGTH OF STRING TO INPUT
'             MsgLine            WHERE IN ZOutTxt$() TO PUT THE EDITED LINE
'             ZRightMargin
'             ZSnoop
'             ZStopInterrupts
'             ZWaitExpired
'
'  OUTPUTS -- ZOutTxt$(MsgLine)  EDITED LINE
'
'  PURPOSE -- Subroutine to edit a line quickly using a minimum of
'             string space.
'
     SUB LineEdit (MsgLine,MaxLen) STATIC
     TabToSpace = 0
     LSET ZLineMes$ = ZOutTxt$(MsgLine)
     Col = LEN(ZOutTxt$(MsgLine))
     ZStopInterrupts = ZTrue
     WasXXX = MaxLen - 3
     ZWaitExpired = ZFalse
     GOTO 3782
3720 Col = Col + 1
     ZAutoLogoff! = TIMER + ZWaitBeforeDisconnect
3730 IF TabToSpace > 0 THEN _
        WasX$ = " " : _
        TabToSpace = TabToSpace - 1 : _
        GOTO 3750
     CALL FindFKey
     IF ZSubParm < 0 THEN _
        EXIT SUB
     WasX$ = ZKeyPressed$
     IF WasX$ = "" THEN _
        GOTO 3732 : _
        IF ZLocalUser THEN _
           GOTO 3733 _
        ELSE GOTO 3732
     IF WasX$ = ZEscape$ THEN _
        ZKeyPressed$ = WasX$ : _
        EXIT SUB
     SendRemote = ZTrue
     WasZ = INSTR(ZLineEditChk$,WasX$)
     IF WasZ < 1 THEN _
        GOTO 3750 _
     ELSE IF WasZ > 4 THEN _
             GOTO 3870 _
     ELSE IF WasZ = 1 THEN _
             GOTO 3810
     IF ZLocalUser THEN _
        GOTO 3730
3732 IF ZCommPortStack$ <> "" THEN _
        WasX$ = LEFT$(ZCommPortStack$,1) : _
        ZCommPortStack$ = RIGHT$(ZCommPortStack$,LEN(ZCommPortStack$)-1) : _
        GOTO 3738
     IF NOT ZLocalUser THEN _
        CALL EofComm (Char) : _
        IF Char <> -1 THEN _
           GOTO 3736
3733 CALL CheckTime(ZAutoLogoff!, TempElapsed!, 1)
     IF TempElapsed! <=0 THEN _
        ZWaitExpired = ZTrue : _
        Col = Col - 1 : _
        GOTO 3850
     CALL Carrier
     IF ZSubParm THEN _
        EXIT SUB
     CALL GoIdle
     GOTO 3730
3736 ZAutoLogoff! = TIMER + ZWaitBeforeDisconnect
3737 CALL GetCom (WasX$)
3738 SendRemote = ZRemoteEcho
3740 ON INSTR(ZLineEditChk$,WasX$) GOTO 3810,3730,3730,3730, _
                                   3870,3870,3870,3870,3870
3750 IF SendRemote THEN _
        CALL PutCom(WasX$)
     CALL LPrnt (WasX$, 0)
     IF WasX$ = ZCarriageReturn$ THEN _
        Col = Col - 1 : _
        GOTO 3850
3770 IF Col > WasXXX THEN _
        IF WasX$ = " " THEN _
           CALL SkipLine (1) : _
           GOTO 3860
3780 MID$(ZLineMes$,Col) = WasX$
3782 IF Col < MaxLen THEN _
        GOTO 3720
     WasZ = Col
3800 IF WasZ < 1 THEN _
        WasZ = Col-1 : _
        GOTO 3820
     IF MID$(ZLineMes$,WasZ,1) = " " THEN _
        GOTO 3820
     WasZ = WasZ - 1
     GOTO 3800
3810 TabToSpace = 5 - (Col MOD 5)
     GOTO 3730
3820 IF (NOT ZRemoteEcho) AND (NOT ZLocalUser) THEN _
        CALL SkipLine (1) : _
        GOTO 3860
     Col = MaxLen - WasZ
     IF ZSnoop THEN _
        IF (POS(0) > Col) AND (Col > 0) THEN _
           LOCATE ,POS(0)-Col: _
           CALL LPrnt(STRING$(Col,32),0)
3830 IF ZRemoteEcho THEN _
        CALL PutCom (STRING$(Col,8) + STRING$(Col,32))
3840 ZOutTxt$(MsgLine) = LEFT$(ZLineMes$,WasZ)
     ZOutTxt$(MsgLine + 1) = MID$(ZLineMes$,WasZ + 1,Col)
     CALL SkipLine (1)
     GOTO 3891
3850 IF SendRemote AND ZLineFeeds THEN _
        CALL PutCom(ZLineFeed$)
3860 ZOutTxt$(MsgLine) = LEFT$(ZLineMes$,Col)
     GOTO 3891
3870 IF Col = 1 THEN _
        GOTO 3730
     Col = Col-2
3880 CALL LPrnt(ZLocalBksp$,0)
3885 IF SendRemote THEN _
        CALL PutCom (ZBackSpace$)
3890 GOTO 3720
3891 CALL Carrier
     END SUB
'
3952 ' $SUBTITLE: 'KillMsg - subroutine to delete messages'
' $PAGE
'
'  NAME    -- KillMsg
'
'  INPUTS  --     PARAMETER                    MEANING
'              MsgToKill                   MESSAGE NUMBER TO KILL
'              ActiveMessages              NUMBER ACTIVE MESSAGES
'
'  OUTPUTS --  NONE
'
'  PURPOSE --  To kill/delete old or unnecessary messages
'
     SUB KillMsg (MsgToKill,ActiveMessages) STATIC
     FIELD #1,128 AS ZMsgRec$
     WasQX = 1
     NumHeaders = 0
3955 IF WasQX > ActiveMessages THEN _
        ZOutTxt$ = "No such msg #" + _
             STR$(MsgToKill) : _
        GOTO 4031
     IF ZMsgPtr(WasQX,2) = MsgToKill AND MsgToKill => 1 THEN _
        GOTO 3970
     WasQX = WasQX + 1
     GOTO 3955
3970 MsgRec = ZMsgPtr(WasQX,1)
     GET 1, MsgRec
     NumHeaders = ASC(MID$(ZMsgRec$,67,1))
     OrigNumHeaders = NumHeaders
3972 CALL ChkIfMsgHeader
     IF NOT ZOK THEN _
        NumHeaders = 0 : _
        GOTO 4032
     IF MID$(ZMsgRec$,116,1) = ZDeletedMsg$ THEN _
        GOTO 4032
     IF ZUserSecLevel >= ZSecKillAny THEN _
        GOTO 4020
3980 ZWasZ$ = MID$(ZMsgRec$,101,15)
     CALL Trim (ZWasZ$)
     IF LEN(ZWasZ$) = 0 THEN _
        GOTO 4030
3990 IF ZWasZ$ = "^READ^" OR ZWasZ$ = "^KILL^" THEN _
        CALL ChkMsgName (MsgFromCaller,MsgToCaller) : _
        CALL MsgNameMatch (ZActiveUserName$,"",6,MsgFromCaller) : _
        CALL MsgNameMatch (ZActiveUserName$,"",37,MsgToCaller) : _
        IF (MsgFromCaller OR MsgToCaller) THEN _
           GOTO 4020 _
        ELSE IF NumHeaders > 1 THEN _
                GOTO 4032 _
             ELSE ZMsgPswd = ZTrue : _
                  ZAttemptsAllowed = 0 : _
                  ZOutTxt$ = "Only sender & receiver can kill" : _
                  GOTO 4031
4000 IF LEFT$(ZWasZ$,1) = "!" THEN _
        ZWasZ$ = MID$(ZWasZ$,2)
4010 ZPswdSave$ = ZWasZ$ + _
                      SPACE$(15 - LEN(ZWasZ$))
     ZAttemptsAllowed = 1
     ZMsgPswd = ZTrue
     CALL PassWrd
     IF ZPswdFailed THEN _
        GOTO 4031
4020 ZWasZ$ = MID$(ZMsgRec$,37,22)
     CALL Trim (ZWasZ$)
     IF OrigNumHeaders < 2 AND ZExpertUser THEN _
        GOTO 4030
     ZOutTxt$ = "Really kill msg#" + STR$(MsgToKill) + " to " + ZWasZ$ + " ([Y],N)"
     ZSubParm = 1
     ZTurboKey = -ZTurboKeyUser
     CALL TGet
     IF ZSubParm < 0 THEN _
        EXIT SUB
     IF ZNo THEN _
        GOTO 4032
4030 ZSubParm = 3
     CALL FileLock
     GET 1, MsgRec
     MID$(ZMsgRec$,116,1) = ZDeletedMsg$
     PUT 1, MsgRec
     ZSubParm = 4
     CALL FileLock
     ZOutTxt$ = "Killed Msg #" + _
          STR$(MsgToKill) + " to " + ZWasZ$
     CALL UpdtCalr (ZOutTxt$,1)
     IF ((ZUserSecLevel < ZSecKillAny) AND NOT MsgFromCaller) THEN _
        NumHeaders = 0
4031 ZSubParm = 5
     CALL TPut
4032 NumHeaders = NumHeaders - 1
     IF NumHeaders > 0 THEN _
        MsgRec = MsgRec + 1 : _
        GET 1, MsgRec : _
        GOTO 3972
     END SUB
'
4554 ' $SUBTITLE: 'SetThread - Sets up the interface for threading'
' $PAGE
'
'  NAME    -- SetThread
'
'  INPUTS  --     PARAMETER                    MEANING
'                 CurMsgNum                 CURRENT MESSAGE NUMBER
'                 CurSubj$                  CURRENT MESSAGE SUBJECT
'
'  OUTPUTS --  ZUserIn$()                   SEARCH MSG BY STRING
'              ZWasQ                        0 IF THREAD CANCELLED
'
'  PURPOSE --  Find out how the caller wants to thread -
'              i.e. search messages by matching subject -
'              forward from current, back from current,
'              or forward from top of messages
'
     SUB SetThread (CurMsgNum,CurSubj$) STATIC
     IF ZWasQ > 1 THEN _
        ZWasZ$ = ZUserIn$(2) : _
        GOTO 4657
4656 ZOutTxt$ = "THREAD: +)forward, -)back, 1)from origin ([ENTER] quits)"
     ZTurboKey = -ZTurboKeyUser
     ZSubParm = 1
     CALL TGet
     IF ZWasQ = 0 OR ZSubParm = -1 THEN _
        EXIT SUB
     ZWasZ$ = ZUserIn$(1)
4657 ZWasZ$ = LEFT$(ZWasZ$,1)
     WasX = INSTR("+-1",ZWasZ$)
     IF WasX = 0 THEN _
        GOTO 4656
     ZUserIn$(1) = "R"
     IF WasX = 1 THEN _
        CurMsgNum = CurMsgNum + 1 _
     ELSE IF WasX = 2 THEN _
             CurMsgNum = CurMsgNum - 1 _
          ELSE CurMsgNum = 1 : _
               ZWasZ$ = "+"
     ZUserIn$(3) = MID$(STR$(CurMsgNum),2) + ZWasZ$
     IF LEN(CurSubj$) < 4 OR LEFT$(CurSubj$,3) <> "(R)" THEN _
        ZUserIn$(2) = CurSubj$ _
     ELSE ZUserIn$(2) = MID$(CurSubj$,4)
     ZUserIn$(2) = LEFT$(ZUserIn$(2) + "  ",22)
     ZLastIndex = 3
     ZAnsIndex = 1
     ZWasQ = 3
     END SUB
'
4773 ' $SUBTITLE: 'SysopChat - chat with sysop'
' $PAGE
'
'  NAME    -- SysopChat
'
'                 PARAMETER                    MEANING
'  INPUTS  --  ChatType                   1 = LINE CHAT NO ANSI
'                                         2 = ANSICHAT
'  OUTPUTS --  ZWasCM                         TRUE IF CHAT ACTIVE
'
'  PURPOSE --  Lets sysop chat interactively with caller
'
     SUB SysopChat (ChatType) STATIC
     ZWasCM = ZTrue
     TimeChatStarted! = TIMER
     ZSubParm = 1
     CALL Line25
     ZOutTxt$(2) = ""
     ON ChatType GOTO 4775,4776
4775 CALL LineEdit (1,72)
     IF ZKeyPressed$ = ZEscape$ OR _
        ZSubParm < 0 THEN _
        GOTO 4777
     ZOutTxt$(1) = ""
     IF ZOutTxt$(2) <> "" THEN _
        ZOutTxt$ = ZOutTxt$(2) : _
        ZOutTxt$(1) = ZOutTxt$(2) : _
        ZOutTxt$(2) = "" _
     ELSE ZOutTxt$ = ""
     ZSubParm = 4
     CALL TPut
     IF ZSubParm > -1 THEN _
        GOTO 4775
     GOTO 4777
4776 CALL ANSIChat
4777 ZWasCM = 0
     CALL CheckTime(TimeChatStarted!,Elapsed!, 2)
     ZSecsPerSession! = ZSecsPerSession! + Elapsed!
     IF NOT ZLocalUser THEN _
        ZAutoLogoff! = TIMER + ZWaitBeforeDisconnect
     CALL QuickTPut("  Chat over.  BBS resuming",2)
     END SUB
'
5100 ' $SUBTITLE: 'RemNonAlf - removes non-alpha chars from a string'
' $PAGE
'
'  NAME    -- RemNonAlf
'
'  INPUTS  --     PARAMETER                    MEANING
'                 Strng$                   STRING TO CHECK
'                 MinChar                  REMOVE CHARS WITH THIS
'                                          ASCII VALUE OR LOWER
'                 MaxChar                  REMOVE CHARS WITH THIS
'                                          ASCII VALUE OR HIGHER
'
'  OUTPUTS --       Strng$                 STRING RETURNED
'
'  PURPOSE --  Remove chars with ASCII value higher than MaxChar and
'              lower than MinChar
'
     SUB RemNonAlf (Strng$,MinChar,MaxChar)
     Last = LEN(Strng$)
     WasJ = 1
     WHILE WasJ <= Last
        WasK = ASC(MID$(Strng$,WasJ))
        IF WasK > MinChar AND WasK < MaxChar THEN _
           WasJ = WasJ + 1 _
        ELSE Strng$ = LEFT$(Strng$,WasJ - 1) + _
                      RIGHT$(Strng$,Last - WasJ) : _
             Last = Last - 1
     WEND
     END SUB
'
5500 ' $SUBTITLE: 'BankTime - Allows User to Bank Session Time'
' $PAGE
'  NAME    -- BankTime
'
'  INPUTS  -- PARAMETER             MEANING
'             ZBankTime          TIME IN BANK CAN USE
'
'  OUTPUTS -- ZBankTime
'
'  PURPOSE -- Allow Users to use Bank session time
'
     SUB BankTime STATIC
     GOSUB 5507
5501 CALL TimeRemain(MinsRemaining)
     ZOutTxt$ = ZFGF$ + STR$(MinsRemaining) + ZFGB$ + _
                " mins left.  " + ZFGF$ + "D" + ZFGB$ + ")eposit, "
     IF ZTimeBankInActive = 0 THEN _
        ZOutTxt$ = ZOutTxt$ + ZFGF$ + "W" + ZFGB$ + ")ithdraw, "
     ZOutTxt$ = ZOutTxt$ + ZFGF$ + "B" + ZFGB$ + ")alance, "
     ZOutTxt$ = ZOutTxt$ + ZFGF$ + "H" + ZFGB$ + ")elp, [Q]" + _
                  ZFGB$ + "uit" + ZEmphasizeOff$
     ZTurboKey = -ZTurboKeyUser
     CALL PopCmdStack
     IF ZSubParm = -1 THEN _
        EXIT SUB
     ZWasZ$ = LEFT$(ZUserIn$(ZAnsIndex),1)
     CALL AllCaps(ZWasZ$)
     ON INSTR("QDWB?H",ZWasZ$) GOTO 5509,5505,5502,5504,5508,5508
     GOTO 5501
5502 IF ZTimeBankInActive THEN _
        CALL SkipLine (1) : _
        CALL QuickTPut1 ("Time Bank Withdrawal In-Active at this Time") : _
        CALL SkipLine (1) : _
        GOTO 5501
     SignTime = 1        ' withdraw time
     MaxTime = ZGlobalBankTime
5503 IF SignTime = 1 THEN _
        ZOutTxt$ = "Withdraw" _
     ELSE ZOutTxt$ = "Deposit"
     BankLog$ = ZOutTxt$ + " "
     Temp$ = ZFGA$ + ZOutTxt$ + ZFG1$ + " how many mins" + ZEmphasizeOff$
     CALL ChangeInt (ZFalse,Temp$,Temp,0,Maxtime)
     IF ZWasQ = 0 OR ZTestedIntValue = 0 THEN _
        GOTO 5501
     BankLog$ = "BANK ACCESS: " + BankLog$ + LTRIM$(STR$(ZTestedIntValue)) + " mins."
     CALL UpdtCalr (BankLog$,2)
     ZTestedIntValue = SignTime * ZTestedIntValue
     CALL ChkAddedTime (ZTestedIntValue)
     IF ZTestedIntValue = 0 THEN _
        GOTO 5501
     ZSecsPerSession! = ZSecsPerSession! + (ZTestedIntValue * 60)
     IF ZMaxPerDay = 0 THEN _
        ZTimeCredits! = ZTimeCredits! + ZTestedIntValue * 60
     ZElapsedTime = ZElapsedTime - ZTestedIntValue
     ZGlobalBankTime = ZGlobalBankTime - ZTestedIntValue
     GOTO 5501
5504 GOSUB 5507
     GOTO 5501
5505 SignTime = -1            ' deposit
     MaxTime = ZMaxBank - ZGlobalBankTime
     IF MaxTime <= 0 THEN _
        CALL QuickTPut1 (ZFGC$ + "Already deposited max of" + _
                        ZFGF$ + STR$(ZMaxBank) + ZEmphasizeOff$) : _
        ZLastIndex = 0 : _
        GOTO 5501
     IF MaxTime > MinsRemaining THEN _
        MaxTime = MinsRemaining
     GOTO 5503
5507 IF ZAnsIndex < ZLastIndex THEN _
        RETURN
     CALL SkipLine(1)
     CALL QuickTPut1 (ZFGB$ + "Time Bank Statistics:" + ZEmphasizeOff$)
     CALL SkipLine(1)
     CALL QuickTPut1 (ZFGB$ + "  Maximum Allowable:    " + ZFGF$ + _
                 STR$(ZMaxBank) + ZFGB$ + " Mins" + ZEmphasizeOff$)
     CALL QuickTPut1 (ZFGB$ + "  Current Bank Balance: " + ZFGF$ + _
                 STR$(ZGlobalBankTime) + ZFGB$ + " Mins" + ZEmphasizeOff$)
     CALL SkipLine(1)
     RETURN
5508 ZFileName$ = ZHelpPath$ + _
                  "UB" + _
                  ZHelpExtension$
     CALL BufFile (ZFileName$,WasX,ZFalse)
     GOTO 5501
5509 END SUB
'
9140 ' $SUBTITLE: 'GetTime - subroutine to calculate elapsed time'
' $PAGE
'
'  NAME    -- GetTime
'
'  INPUTS  --     PARAMETER                    MEANING
'                ZTimeLoggedOn$
'
'  OUTPUTS --  ZSessionHour               NUMBER OF HOURS ON
'              ZSessionMin                NUMBER OF MINUTES ON
'              ZSessionSec                NUMBER OF SECONDS ON
'
'  PURPOSE --  Calculate the elapsed time a user has been on
'
     SUB GetTime
     CALL CheckTime(ZUserLogonTime!, TempElapsed!, 2)
     ZSessionHour = TempElapsed! / 3600
     ZSessionMin = (TempElapsed! - ZSessionHour * 3600!) / 60
     ZSessionSec = TempElapsed! - (ZSessionHour * 3600! + ZSessionMin * 60!)
     IF ZSessionSec < 0 THEN _
        ZSessionSec = ZSessionSec + 60 : _
        ZSessionMin = ZSessionMin - 1
     IF ZSessionMin < 0 THEN _
        ZSessionMin = ZSessionMin + 60 : _
        ZSessionHour = ZSessionHour - 1
     END SUB
'
9600 ' $SUBTITLE: 'DefaultU - subroutine to update user defauts'
' $PAGE
'
'  NAME    -- DefaultU
'
'  INPUTS  --     PARAMETER                    MEANING
'             ZAutoDownDesired
'             ZBoldText$              ANSI BOLD (0 NO, 1 YES)
'             ZCheckBulletLogon
'             ZExpertUser
'             ZWasGR
'             ZLastMsgRead
'             ZLineFeeds
'             ZNulls
'             ZPageLength
'             ZPromptBell
'             ZRegDate$
'             ZReqQuesAnswered
'             ZRightMargin
'             ZSkipFilesLogon
'             ZTimesLoggedOn
'             ZUpperCase
'             ZUserOption$
'             ZUserTextColor          ANSI OF COLOR (31-37)
'             ZUserXferDefault$
'
'  OUTPUTS--  USER.OPTONS$
'
'  PURPOSE --  To update the user's record with their options.
'  Meaning of graphics preference stored is as follows: where # is
'  value stored for the color.  E.g. if graphics perference for text
'  files is color, and preference for normal text is light yellow,
'  graphics preference stored is 38.  Colors are Red, Green, Yellow,
'  Blue, Purple, Cyan, and White.
'
'             normal                  bold
' Graphics R  G  Y  B  P  C  W    R  G  Y  B  P  C  W
'   none  30 33 36 39 42 45 48 | 51 54 57 60 63 66 69
'   ansi  31 34 37 40 43 46 49 | 52 55 58 61 64 67 70
'  color  32 35 38 41 44 47 50 | 53 56 59 62 65 68 71
'
     SUB DefaultU
     ZWasA =    -ZPromptBell          -2 * ZExpertUser _
            -4 * ZNulls               -8 * ZUpperCase _
           -16 * ZLineFeeds          -32 * ZCheckBulletLogon _
           -64 * ZSkipFilesLogon    -128 * ZAutoDownDesired _
          -256 * ZReqQuesAnswered   -512 * ZMailWaiting _
         -1024 * (NOT ZHiLiteOff)  -2048 * ZTurboKeyUser _
         -4096 * ZFileWaiting      -8192 * ZAvailableForChat
     WasX = 3*ZUserTextColor - 63 + 21*VAL(ZBoldText$) + ZWasGR
     IF WasX < 1 OR WasX > 255 THEN _
        WasX = 48
     LSET ZUserOption$ = _
        MKI$(ZTimesLoggedOn) + _
        MKI$(ZLastMsgRead) + _
        ZUserXferDefault$ + _
        CHR$(WasX) + _
        MKI$(ZRightMargin) + _
        MKI$(ZWasA) + _
        ZRegDate$ + _
        CHR$(ZPageLength) + _
        ZEchoer$
     END SUB
'
9801 ' $SUBTITLE: 'WhosOn - subroutine to display who is on'
' $PAGE
'
'  NAME    -- WhosOn
'
'  INPUTS  --     PARAMETER                    MEANING
'                NumNodes                   # OF NODES TO CHECK
'                ZActiveMessageFile$        CURRENT MESSAGE FILE
'                ZOrigMsgFile$              MAIN MSG FILE
'
'  OUTPUTS --  None
'
'  PURPOSE --  To display who is on each node.
'
     SUB WhosOn (NumNodes) STATIC
     CALL SkipLine (1)
     WasA1$ = ZActiveMessageFile$
     ZActiveMessageFile$ = ZOrigMsgFile$
     CALL OpenMsg
     FIELD 1, 128 AS ZMsgRec$
     GET 1,1
     NumNodes = VAL(MID$(ZMsgRec$,127))
     FOR NodeIndex = 2 TO NumNodes + 1
        GET 1,NodeIndex
        ZOutTxt$ = ZFGF$ + "Node" + _
             STR$(NodeIndex - 1) + ZFGE$
        WasAX$ = MID$(ZMsgRec$,79,5)
        CALL Trim (WasAX$)
        WasAX$ = RIGHT$("     " + WasAX$,5) + _
              " BPS: "
        IF MID$(ZMsgRec$,55,2) = "-1" AND NOT ZSysop THEN _
           ZWasY$ = "SYSOP" + SPACE$(21) _
        ELSE ZWasY$ = MID$(ZMsgRec$,1,26)
        WasAX$ = WasAX$ + ZFGA$ + ZWasY$
        IF MID$(ZMsgRec$,40,2) <> "-1" THEN _
           WasAX$ = WasAX$ + ZFG1$ + MID$(ZMsgRec$,93,22)
'        IF MID$(ZMsgRec$,40,2) <> "-1" THEN
'           CALL SaveUserActivity(WhatTheyDoin$, NodeIndex, ZTrue)
'           IF WhatTheyDoin$ = "C" THEN
'              WasAX$ = WasAX$ + ZFG4$ + "[In Chat System]"
'           ELSEIF WhatTheyDoin$ = "F" THEN
'              WasAX$ = WasAX$ + ZFG4$ + "[In File System]"
'           ELSEIF WhatTheyDoin$ = "M" THEN
'              WasAX$ = WasAX$ + ZFG4$ + "[In Message System]"
'           ELSE
'              WasAX$ = WasAX$ + ZFG4$ + MID$(ZMsgRec$,93,22)
'           END IF
'        ELSE
'           WasAX$ = WasAX$ + ZFG4$ + "[Has Opened a Door]"
'        END IF
        IF MID$(ZMsgRec$,57,1) = "A" THEN _
           ZOutTxt$ = ZOutTxt$ + "  Online at " + _
                WasAX$ _
        ELSE IF NOT ZSysop THEN _
                ZOutTxt$ = ZOutTxt$ + _
                     " Waiting for next caller" _
             ELSE ZOutTxt$ = ZOutTxt$ + _
                       " Offline at " + _
                       WasAX$
        CALL QuickTPut1 (ZOutTxt$)
        CALL AskMore ("",ZTrue,ZTrue,ZAnsIndex,ZFalse)
        IF ZNo THEN _
           NodeIndex = NumNodes + 2
     NEXT
     ZActiveMessageFile$ = WasA1$
'     IF NOT ZAllowInternodeChat THEN _
'        CALL SkipLine(1) : _
'        CALL AskMore ("",ZTrue,ZFalse,ZAnsIndex,ZTrue)
     IF NOT ZExpertUser THEN _
        CALL SkipLine (1) : _
        CALL AskMore ("",ZTrue,ZFalse,ZAnsIndex,ZTrue)
     CALL QuickTPut (ZEmphasizeOff$,0)
     END SUB
'
' $SUBTITLE: 'AliasChk - Checks whether ALIAS exists'
'
' $PAGE
'          Alias sub 1989-94(c) Gregg Snyder
'
'  SUBROUTINE NAME    -- AliasChk
'
'  INPUT PARAMETERS   --  PARAMETER                   MEANING
'                         WhoFind$                    ALIAS to find
'
'  OUTPUT PARAMETERS  --  WhoFound                    Whether ALIAS found
'                         UserNumFound                Record # of User
'
'  SUBROUTINE PURPOSE --  Validate that ALIAS exists.  Get User Record
'
9900 SUB AliasChk (WhoFind$,WhoFound,TempWhoFind$,AliasConf) STATIC
     IF WhoFound = ZTrue THEN EXIT SUB
     CALL BreakFileName (ZMainUserFile$,Drive$,Prefix$,Ext$,ZTrue)
     DGSTemp = INSTR(ZConfName$," ")
     IF DGSTemp > 0 THEN _
      DGSFileName$ = Drive$ + LEFT$(ZConfName$,DGSTemp-1) + "A.DEF" _
     ELSE DGSFileName$ = Drive$ + ZConfName$ + "A.DEF"
     CALL FindIt (DGSFileName$)
     IF NOT ZOK THEN _
        AliasConf = ZFalse : _
        EXIT SUB
     AliasConf = ZTrue
     CALL OpenWork (7,DGSFileName$,ZFalse)
     WhoFound=ZFalse
     TempWhoFind$ = ""
     WHILE TempWhoFind$ = "" AND NOT EOF(7)
        INPUT #7, DGSUserName$, DGSTempAlias$
        IF DGSTempAlias$ = ZSecretName$ THEN _
           GOTO 9950
        IF DGSTempAlias$ = WhoFind$ THEN _
           TempWhoFind$ = DGSUserName$ : _
           WhoFound = ZTrue : _
           EXIT SUB
        InTo = INSTR(DGSTempAlias$,WhoFind$)
        IF InTo > 0 THEN
          Temp = LEN(WhoFind$)
          TempMsgToWork$ = MID$(DGSTempAlias$,1,Into - 1) + ZEmphasizeOn$ + WhoFind$ + _
                            ZEmphasizeOff$ + ZFGF$ + MID$(DGSTempAlias$,InTo + Temp)
          ZOutTxt$ = ZFGE$ + "Send to: " + ZFGF$ + TempMsgToWork$ + _
                     ZFGE$ + " ( " + ZFGF$ + "Y" + ZFGE$ + ")es, [N]" + _
                     ZFGE$ + ")o, " + ZFGF$ + "A" + ZFGE$ + ")bort )" + ZEmphasizeOff$
          ZSubParm = 1
          Call TGet
          IF ZSubParm = -1 THEN _
             EXIT SUB
          IF ZWasQ = 0 THEN _
             GOTO 9950
          CALL AllCaps (ZUserIn$)
          IF ZUserIn$ = "A" THEN _
             CLOSE 7 : _
             EXIT SUB
          IF ZYes THEN
             WhoFound = ZTrue
             WhoFind$ = DGSTempAlias$
             TempWhoFind$ = DGSUserName$
           END IF
        END IF
9950 WEND
     CLOSE 7
     END SUB
'
9960 '$SUBTITLE: 'AliasDGS - Subroutine to Create/Update Alias Info file'
' $PAGE
'
'          Alias sub 1989-94(c) Gregg Snyder
'
'  SUBROUTINE NAME    -- DGSAlias
'
'  INPUT PARAMETERS   --  PARAMETER                   MEANING
'                         ZConfName$                  CONFERENCE NAME
'                         ZOrigUserNameDGS$           USERS - LOG ON NAME
'                         DGSAlias$                   USERS - ALIAS NAME
'                         DGSStl$                     NULL FIRST TIME IN
'                                                     'STILL' IF ALIAS EXISTS
'                                                        OR REAL NAME
'                         DGSFileName$                CONFERENCE ALIAS FILE
'
'  OUTPUT PARAMETERS  --  ZConfName$ ZOrigUserNameDGS$ DGSAlias$ DGSStl$
'                         DGSFileName$
'
'  SUBROUTINE PURPOSE --  TO Read ConfA.DEF and Get Users ALIAS or
'                         Create One
'
     SUB AliasDGS (ZConfName$,ZOrigUserNameDGS$,DGSAlias$,DGSStl$,DGSFileName$) STATIC
     ZAliasMode = ZFalse
     IF DGSStl$ = "" THEN
        ConfADefFlag = 0
        CALL BreakFileName (ZMainUserFile$,Drive$,Prefix$,Ext$,ZTrue)
        DGSFileName$ = Drive$ + ZConfName$ + "A.DEF"
        CALL FindIt (DGSFileName$)
        IF ZOK THEN
           ConfADefFlag = ZTrue
           ZAliasMode = ZTrue
        END IF
        IF ConfADefFlag = ZTrue THEN
         Call OpenWork (7,DGSFileName$,ZFalse)
           DGSAlias$ = ""
           WHILE DGSAlias$ = "" AND NOT EOF(7)
              INPUT #7, DGSUserName$, DGSTempAlias$
              DGSUnl = LEN(DGSUserName$)
              IF DGSUserName$ = LEFT$(ZOrigUserNameDGS$,DGSUnl) THEN
                 DGSAlias$ = DGSTempAlias$
              END IF
           WEND
           CLOSE 7
        ELSE
           DGSAlias$ = "NO CONFA.DEF"
           EXIT SUB
        END IF
     END IF
     CALL GoodAls (ZConfName$,ZOrigUserNameDGS$,DGSAlias$,DGSStl$,DGSFileName$)
     END SUB
'
' $SUBTITLE: 'GoodAls - Subroutine to Make Sure Alias Good'
' $PAGE
'
'          Alias sub 1989-94(c) Gregg Snyder
'
'  SUBROUTINE NAME    -- GoodAls
'
'  INPUT PARAMETERS   --  PARAMETER                   MEANING
'                         ZConfName$                  CONFERENCE NAME
'                         ZOrigUserNameDGS$           USERS - LOG ON NAME
'                         DGSAlias$                   USERS - ALIAS NAME
'                         DGSStl$                     NULL FIRST TIME IN
'                                                      'STILL' IF ALIAS EXISTS
'                                                         OR REAL NAME
'                         DGSFileName$                CONFERENCE ALIAS FILE
'
'  OUTPUT PARAMETERS  --  ZConfName$ ZOrigUserNameDGS$ DGSAlias$ DGSStl$
'                         DGSFileName$
'
'  SUBROUTINE PURPOSE --  To Read ConfA.DEF and see if Users ALIAS is
'                         Aready in Use or a Real Name
'
     SUB GoodAls (ZConfName$,ZOrigUserNameDGS$,DGSAlias$,DGSStl$,DGSFileName$) STATIC
     IF DGSAlias$ = "" THEN
        DGSSfnSln$ = ZSysopFirstName$+" "+ZSysopLastName$
        ZOutTxt$ = "Do you" +DGSStl$+ " want to use an Alias? (Y,[N])"
        ZSubParm = 1
        CALL TGet
        IF ZYes THEN
           ABFlg$ = ""
           ZOutTxt$ = "Enter Alias (31 Char. Max.) "
           ZSubParm = 1
           CALL TGet
           CALL AllCaps (ZUserIn$)
           IF ZUserIn$ = "" OR INSTR(SPACE$(31),ZUserIn$) > 0 THEN
              ZUserIn$ = ""
              ABFlg$ = "Alias Must NOT be Blank"
           END IF
           IF LEN(ZUserIn$) > 31 THEN
              ZUserIn$= ""
              ABFlg$ = "Length Must NOT Exceed 31 Characters"
           END IF
           IF ZUserIn$ = "SYSOP" OR ZUserIn$ = DGSSfnSln$ THEN
              ZOutTxt$ = CHR$(7)+CHR$(7)
              ZOutTxt$ = ZOutTxt$ + "Wrong Answer! Alias Request Denied!"
              ZOutTxt$ = ZOutTxt$ + CHR$(13) + "Contact Sysop for Alias Retry"
              CALL QuickTPut (ZOutTxt$,2)
              DGSAlias$ = ZOrigUserNameDGS$+CHR$(250)
              ZActiveUserName$ = ZOrigUserNameDGS$+CHR$(250)
              ZFirstName$ = ZOrigUserNameDGS$+CHR$(250)
           ELSE
              Call OpenWork (7,DGSFileName$,ZFalse)
              WHILE ABFlg$ = "" AND NOT EOF(7)
              INPUT #7, DGSUserName$, DGSTempAlias$
              IF ZUserIn$ = DGSUserName$ THEN
                 ABFlg$ = " is a Real User"
              ELSE
                 IF ZUserIn$ = DGSTempAlias$ THEN
                    ABFlg$ = " has Already been Used"
                 END IF
              END IF
              WEND
              CLOSE 7
              IF ABFlg$="" THEN
                 DGSAlias$ = ZUserIn$
                 ZActiveUserName$ = ZUserIn$
                 ZFirstName$ = ZUserIn$
              ELSE
                 ZOutTxt$="Sorry "+ZFirstName$+" but "+ZUserIn$+ABFlg$
                 CALL QuickTPut (ZOutTxt$,1)
                 DGSStl$ = " still"
                 DGSAlias$ = ""
              END IF
          END IF
        ELSE
           DGSAlias$ = ZOrigUserNameDGS$
        END IF
        IF DGSAlias$ <> "" THEN
           CLOSE 2
           FOR I = 1 TO LEN(DGSAlias$)
              IF MID$(DGSAlias$,I,1)=CHR$(34) THEN MID$(DGSAlias$,I,1)=CHR$(39)
           NEXT I
           Call OpenWork (2,DGSFileName$,ZTrue)
           WRITE #2, ZOrigUserNameDGS$, DGSAlias$
           CLOSE 2
        END IF
      ELSE
        ZActiveUserName$ = DGSAlias$
        ZFirstName$ = DGSAlias$
      END IF
      END SUB
'
10000 ' $SUBTITLE: 'IConference - subroutine to read the I.DEF file'
' $PAGE
'
'  NAME    -- IConference
'
'                                  MEANING
'  INPUTS  -- ZMainMsgFile$        NAME OF MAIN MESSAGE BASE
'
'  OUTPUTS -- MsgTo$               WHO MESSAGE IS ADDRESSED TO
'             FirstLineText$       TEXT TO APPEAR ON 1ST LINE OF
'                                  MESSAGE
'             SecondLineText$      TEXT TO APPEAR ON 2ND LINE OF
'                                  MESSAGE
'             AddressLine          WHICH LINE TO APPEND ADDRESSING
'                                  INFORMATION TO, LINE 1 OR LINE 2
'                                  (FirstLineText$ or SecondLineText$)
'
'  PURPOSE -- For conferences that require special addressing to
'             appear in the first one or two lines of the message.
'
'             The file can contain up to five parameters in the format
'             of:  XXX,YYY,ZZZ,# (each parm seperated by a comma)
'
'             Parm #1 = contains who message is addressed to (ex. UUCP)
'                       in the "TO:" field of message header
'             Parm #2 = what text is to appear on line one of the
'                       body of the message
'             Parm #3 = what text is to appear on line two of the
'                       body of the message
'             Parm #4 = What line should a message address be appended
'                       to (valid entries are 1 or 2)
'             Parm #5 = File to be displayed to user if Parm #2 is
'                       not blank.  Just enter the 7 character name
'                       of this file as RBBS will automatically build
'                       the path and the extension to this file.  The
'                       path is the path to your HELP files and the
'                       extension is the extension defined for help (both
'                       of these are defined in config).  This file
'                       will not be shown is Parm #2 is not used.
'
'
        SUB IConference (ZMainMsgFile$,MsgTo$,FirstLineText$,SecondLineText$,AddressLine)
        CALL BreakFileName (ZMainMsgFile$,Drive$,Prefix$,Ext$,ZTrue)
        EMAILFileName$ = Drive$ + MID$(ZConfName$,1,INSTR(ZConfName$," ")-1) + "I.DEF"
        CALL FindFile (EMAILFileName$,ZOK)
        IF ZOK THEN
           ZNetConference = ZTrue
           CALL OpenWork (2,EMAILFileName$,ZFalse)
           CALL ReadParms (ZWorkAra$(),5,1)
           MsgTo$ = ZWorkAra$(1)
           FirstLineText$ = ZWorkAra$(2)
           SecondLineText$ = ZWorkAra$(3)
           AddressLine = VAL(ZWorkAra$(4))
           IHelpFile$ = ZWorkAra$(5)
           CLOSE 2
           CALL FindFile (IHelpFile$,ZOK)
           IF ZOK THEN
              ZNonStop = ZTrue
              CALL Graphic (IHelpFile$,ZTrue)
              CALL BufFile (IHelpFile$,ZWasX,ZFalse)
           END IF
        END IF
        END SUB
'
85000 ' $SUBTITLE: 'ReadXfer - subroutine to read the xfer file'
' $PAGE
'
'  NAME    -- ReadXfer
'                                  MEANING
'  INPUTS  -- XFER?.DEF      OPENED AS WORKFILE #2
'
'  OUTPUTS -- XFerErr         1 = IF WE CANNOT READ THE FILE, OR IF
'                                 WE CANNOT READ PARAMETER 4.
'                             0 = YES WE CAN READ THE FILE
'
'             ZXferInfo$      THIS STRING IS SETUP WITH THE FOLLOWING
'                             STRUCTURE:
'
'                             FILENAME<CR>FAILURE-PARM<CR>
'
'             ZXfer           SET TO THE LENGTH OF ZXferInfo$ FILE
'
'
'  PURPOSE -- Read the XFER?.DEF file to determine file transfer success
'             We get the ZFailParam and ZFilePosition from 21623 in
'             RBBSSUB3.BAS
'
'  NOTE:  New variable added to RBBS-VAR.BAS => ZFilePosition
'
      SUB ReadXfer (XferErr) STATIC
      IF ZAdvanceProtoWrite AND ZFailureParm = 4 THEN _
         ZFailureParm = ZFailureParm - 3
      ZXferInfo$ = ""
      WHILE NOT EOF(2)
          CALL ReadAny
          FOR J = 1 TO ZFilePosition
              IF INSTR(ZOutTxt$, " ") THEN
                 Temp2$ = MID$(ZOutTxt$, 1, INSTR(ZOutTxt$, " "))
                 ZOutTxt$ = MID$(ZOutTxt$, INSTR(ZOutTxt$, " "), LEN(ZOutTxt$))
                 ZOutTxt$ = LTRIM$(ZOutTxt$)
                 Temp2$ = RTRIM$(Temp2$)
                 IF J = ZFailureParm THEN
                    IF Temp2$ = "B" OR Temp2$ = "H" AND ZTransferFunction = 1 THEN
                       J = ZFilePosition + 1
                    ELSE
                       IF VAL(Temp2$) > 96 AND VAL(Temp2$) < 123 THEN
                          Temp2$ = UCASE$(Temp2$)
                       END IF
                       ZXferInfo$ = ZXferInfo$ + Temp2$ + _
                                    ZCarriageReturn$
                    END IF
                 END IF
                 IF J = ZFilePosition THEN
                    ZXferInfo$ = ZXferInfo$ + Temp2$ + _
                                 ZCarriageReturn$
                    TempCheck$ = Temp2$
                    J = ZFilePosition + 1
                 END IF
              ELSE
                 IF J = ZFilePosition AND TempCheck$ = "" THEN
                    ZXferInfo$ = ZXferInfo$ + ZOutTxt$ + _
                                 ZCarriageReturn$
                 END IF
                 J = ZFilePosition + 1
              END IF
          NEXT
      WEND
      IF ZMarkedFiles$ <> "" AND ZXferInfo$ <> "" THEN _
         GOSUB 86000
      ZXferC = LEN(ZXferInfo$)
      IF ZAdvanceProtoWrite AND ZXferInfo$ = "" THEN _
         XferErr = -1
      EXIT SUB
'
'  The following section will use the variables from the ReadXfer
'  subroutine above, and compare the filenames against the filenames
'  in the ZMarkedFiles$ string.  If the filenames match but the
'  transfer of that file was unsuccessful, the file is added into
'  the variable ZDGSMarkedFiles$.  If the filenames match and the
'  transfer was successful, the file is NOT added into the variable
'  ZDGSMarkedFiles$.  At line 21760 (SUB5), if the transfer was
'  successful ZMarkedFiles$ is set equal to ZDGSMarkedFiles$ so the
'  file(s) the user was not able to download remain as marked files.
'
'  Temp$  = FILENAME FROM MARKED FILE LIST
'  Temp2$ = FILENAME FROM XFER
'  Temp3$ = FAILURE PARM FROM XFER
'
'  MatchFile = 0 - FILE IN MarkedFile List BUT NOT IN XFER
'                  PUT FILE BACK IN MarkedFile List
'  MatchFile = 1 - FILE IN Xfer AND D/L SUCCESSFUL
'                  DO NOT PUT FILE BACK IN MarkedFile List
'  MatchFile = 2 - FILE IN Xfer AND D/L UNSUCCESSFUL
'                  PUT FILE BACK IN MarkedFile List
'
86000 EndFile = LEN (ZMarkedFiles$)
      EndFile2 = LEN (ZXferInfo$)
      StartFile = 1
      WHILE StartFile < EndFile
        Temp = INSTR(StartFile,ZMarkedFiles$,ZCarriageReturn$)
        Temp$ = MID$(ZMarkedFiles$,StartFile,Temp-StartFile)
        StartFile2 = 1
        MatchFile = 0
        WHILE StartFile2 < EndFile2
           Temp2 = INSTR(StartFile2,ZXferInfo$,ZCarriageReturn$)
           Temp2$ = MID$(ZXferInfo$,StartFile2,Temp2-StartFile2)
           Temp3 = INSTR(Temp2+1,ZXferInfo$,ZCarriageReturn$)
           Temp3$ = MID$(ZXferInfo$,Temp2+1,Temp3-(Temp2+1))
           CALL BreakFileName (Temp3$,DR$,ZWasY$,WasX$,ZTrue)
           ZFileNameHold$ = ZWasY$ + WasX$
           IF ZFileNameHold$ = Temp$ THEN
              IF Temp2$ <> ZFailureString$ THEN
                  MatchFile = 1
              END IF
              IF Temp2$ = ZFailureString$ THEN
                 MatchFile = 2
              END IF
           END IF
           IF MatchFile = 2 THEN
              GOSUB 86100
              StartFile2 = EndFile2
           END IF
           StartFile2 = Temp3 + 1
        WEND
        IF MatchFile = 0 THEN
           GOSUB 86100
        END IF
        StartFile = Temp + 1
      WEND
      ZMarkedFiles$ = ""
      RETURN
86100 ZDGSMarkedFiles$ = ZDGSMarkedFiles$ + Temp$ + ZCarriageReturn$
      RETURN
      END SUB
86500 ' $SUBTITLE: 'FindFileNumber - To locate file by number'
' $PAGE
'
'  NAME    -- FindFileNumber
'                                  MEANING
'  INPUTS  -- UserEntry$      USER ENTERED FILENUMBER
'
'  OUTPUTS -- MarkName$       FILENAME FOUND FROM USER ENTERED NUMBER
'             NumFound        TRUE = FOUND A FILE
'                             FALSE = DID NOT FIND A FILE
'
      SUB FindFileNumber(UserEntry$,MarkName$,NumFound)
      NumFound = ZFalse
      Count = 1
      StartFile = 1
      CALL AllCaps (UserEntry$)
      EndFile = LEN (ZMarkFileNumber$)
      WHILE StartFile < EndFile
            LetterTemp = INSTR(StartFile,ZMarkFileNumber$,ZCarriageReturn$)
            LetterTemp$ = MID$(ZMarkFileNumber$,StartFile,LetterTemp-StartFile)
            StartFile = LetterTemp + 1
            IF Count = VAL(UserEntry$) THEN _
               MarkName$ = UCASE$(LetterTemp$) : _
               StartFile = EndFile + 1 : _
               NumFound = ZTrue
            Count = Count + 1
      WEND
      END SUB
